(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;

var _import = require('./handlebars/base');

var base = _interopRequireWildcard(_import);

// Each of these augment the Handlebars object. No need to setup here.
// (This is done to easily share code between commonjs and browse envs)

var _SafeString = require('./handlebars/safe-string');

var _SafeString2 = _interopRequireWildcard(_SafeString);

var _Exception = require('./handlebars/exception');

var _Exception2 = _interopRequireWildcard(_Exception);

var _import2 = require('./handlebars/utils');

var Utils = _interopRequireWildcard(_import2);

var _import3 = require('./handlebars/runtime');

var runtime = _interopRequireWildcard(_import3);

var _noConflict = require('./handlebars/no-conflict');

var _noConflict2 = _interopRequireWildcard(_noConflict);

// For compatibility and usage outside of module systems, make the Handlebars object a namespace
function create() {
  var hb = new base.HandlebarsEnvironment();

  Utils.extend(hb, base);
  hb.SafeString = _SafeString2['default'];
  hb.Exception = _Exception2['default'];
  hb.Utils = Utils;
  hb.escapeExpression = Utils.escapeExpression;

  hb.VM = runtime;
  hb.template = function (spec) {
    return runtime.template(spec, hb);
  };

  return hb;
}

var inst = create();
inst.create = create;

_noConflict2['default'](inst);

inst['default'] = inst;

exports['default'] = inst;
module.exports = exports['default'];
},{"./handlebars/base":2,"./handlebars/exception":3,"./handlebars/no-conflict":4,"./handlebars/runtime":5,"./handlebars/safe-string":6,"./handlebars/utils":7}],2:[function(require,module,exports){
'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports.HandlebarsEnvironment = HandlebarsEnvironment;
exports.createFrame = createFrame;

var _import = require('./utils');

var Utils = _interopRequireWildcard(_import);

var _Exception = require('./exception');

var _Exception2 = _interopRequireWildcard(_Exception);

var VERSION = '3.0.1';
exports.VERSION = VERSION;
var COMPILER_REVISION = 6;

exports.COMPILER_REVISION = COMPILER_REVISION;
var REVISION_CHANGES = {
  1: '<= 1.0.rc.2', // 1.0.rc.2 is actually rev2 but doesn't report it
  2: '== 1.0.0-rc.3',
  3: '== 1.0.0-rc.4',
  4: '== 1.x.x',
  5: '== 2.0.0-alpha.x',
  6: '>= 2.0.0-beta.1'
};

exports.REVISION_CHANGES = REVISION_CHANGES;
var isArray = Utils.isArray,
    isFunction = Utils.isFunction,
    toString = Utils.toString,
    objectType = '[object Object]';

function HandlebarsEnvironment(helpers, partials) {
  this.helpers = helpers || {};
  this.partials = partials || {};

  registerDefaultHelpers(this);
}

HandlebarsEnvironment.prototype = {
  constructor: HandlebarsEnvironment,

  logger: logger,
  log: log,

  registerHelper: function registerHelper(name, fn) {
    if (toString.call(name) === objectType) {
      if (fn) {
        throw new _Exception2['default']('Arg not supported with multiple helpers');
      }
      Utils.extend(this.helpers, name);
    } else {
      this.helpers[name] = fn;
    }
  },
  unregisterHelper: function unregisterHelper(name) {
    delete this.helpers[name];
  },

  registerPartial: function registerPartial(name, partial) {
    if (toString.call(name) === objectType) {
      Utils.extend(this.partials, name);
    } else {
      if (typeof partial === 'undefined') {
        throw new _Exception2['default']('Attempting to register a partial as undefined');
      }
      this.partials[name] = partial;
    }
  },
  unregisterPartial: function unregisterPartial(name) {
    delete this.partials[name];
  }
};

function registerDefaultHelpers(instance) {
  instance.registerHelper('helperMissing', function () {
    if (arguments.length === 1) {
      // A missing field in a {{foo}} constuct.
      return undefined;
    } else {
      // Someone is actually trying to call something, blow up.
      throw new _Exception2['default']('Missing helper: "' + arguments[arguments.length - 1].name + '"');
    }
  });

  instance.registerHelper('blockHelperMissing', function (context, options) {
    var inverse = options.inverse,
        fn = options.fn;

    if (context === true) {
      return fn(this);
    } else if (context === false || context == null) {
      return inverse(this);
    } else if (isArray(context)) {
      if (context.length > 0) {
        if (options.ids) {
          options.ids = [options.name];
        }

        return instance.helpers.each(context, options);
      } else {
        return inverse(this);
      }
    } else {
      if (options.data && options.ids) {
        var data = createFrame(options.data);
        data.contextPath = Utils.appendContextPath(options.data.contextPath, options.name);
        options = { data: data };
      }

      return fn(context, options);
    }
  });

  instance.registerHelper('each', function (context, options) {
    if (!options) {
      throw new _Exception2['default']('Must pass iterator to #each');
    }

    var fn = options.fn,
        inverse = options.inverse,
        i = 0,
        ret = '',
        data = undefined,
        contextPath = undefined;

    if (options.data && options.ids) {
      contextPath = Utils.appendContextPath(options.data.contextPath, options.ids[0]) + '.';
    }

    if (isFunction(context)) {
      context = context.call(this);
    }

    if (options.data) {
      data = createFrame(options.data);
    }

    function execIteration(field, index, last) {
      if (data) {
        data.key = field;
        data.index = index;
        data.first = index === 0;
        data.last = !!last;

        if (contextPath) {
          data.contextPath = contextPath + field;
        }
      }

      ret = ret + fn(context[field], {
        data: data,
        blockParams: Utils.blockParams([context[field], field], [contextPath + field, null])
      });
    }

    if (context && typeof context === 'object') {
      if (isArray(context)) {
        for (var j = context.length; i < j; i++) {
          execIteration(i, i, i === context.length - 1);
        }
      } else {
        var priorKey = undefined;

        for (var key in context) {
          if (context.hasOwnProperty(key)) {
            // We're running the iterations one step out of sync so we can detect
            // the last iteration without have to scan the object twice and create
            // an itermediate keys array.
            if (priorKey) {
              execIteration(priorKey, i - 1);
            }
            priorKey = key;
            i++;
          }
        }
        if (priorKey) {
          execIteration(priorKey, i - 1, true);
        }
      }
    }

    if (i === 0) {
      ret = inverse(this);
    }

    return ret;
  });

  instance.registerHelper('if', function (conditional, options) {
    if (isFunction(conditional)) {
      conditional = conditional.call(this);
    }

    // Default behavior is to render the positive path if the value is truthy and not empty.
    // The `includeZero` option may be set to treat the condtional as purely not empty based on the
    // behavior of isEmpty. Effectively this determines if 0 is handled by the positive path or negative.
    if (!options.hash.includeZero && !conditional || Utils.isEmpty(conditional)) {
      return options.inverse(this);
    } else {
      return options.fn(this);
    }
  });

  instance.registerHelper('unless', function (conditional, options) {
    return instance.helpers['if'].call(this, conditional, { fn: options.inverse, inverse: options.fn, hash: options.hash });
  });

  instance.registerHelper('with', function (context, options) {
    if (isFunction(context)) {
      context = context.call(this);
    }

    var fn = options.fn;

    if (!Utils.isEmpty(context)) {
      if (options.data && options.ids) {
        var data = createFrame(options.data);
        data.contextPath = Utils.appendContextPath(options.data.contextPath, options.ids[0]);
        options = { data: data };
      }

      return fn(context, options);
    } else {
      return options.inverse(this);
    }
  });

  instance.registerHelper('log', function (message, options) {
    var level = options.data && options.data.level != null ? parseInt(options.data.level, 10) : 1;
    instance.log(level, message);
  });

  instance.registerHelper('lookup', function (obj, field) {
    return obj && obj[field];
  });
}

var logger = {
  methodMap: { 0: 'debug', 1: 'info', 2: 'warn', 3: 'error' },

  // State enum
  DEBUG: 0,
  INFO: 1,
  WARN: 2,
  ERROR: 3,
  level: 1,

  // Can be overridden in the host environment
  log: function log(level, message) {
    if (typeof console !== 'undefined' && logger.level <= level) {
      var method = logger.methodMap[level];
      (console[method] || console.log).call(console, message); // eslint-disable-line no-console
    }
  }
};

exports.logger = logger;
var log = logger.log;

exports.log = log;

function createFrame(object) {
  var frame = Utils.extend({}, object);
  frame._parent = object;
  return frame;
}

/* [args, ]options */
},{"./exception":3,"./utils":7}],3:[function(require,module,exports){
'use strict';

exports.__esModule = true;

var errorProps = ['description', 'fileName', 'lineNumber', 'message', 'name', 'number', 'stack'];

function Exception(message, node) {
  var loc = node && node.loc,
      line = undefined,
      column = undefined;
  if (loc) {
    line = loc.start.line;
    column = loc.start.column;

    message += ' - ' + line + ':' + column;
  }

  var tmp = Error.prototype.constructor.call(this, message);

  // Unfortunately errors are not enumerable in Chrome (at least), so `for prop in tmp` doesn't work.
  for (var idx = 0; idx < errorProps.length; idx++) {
    this[errorProps[idx]] = tmp[errorProps[idx]];
  }

  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, Exception);
  }

  if (loc) {
    this.lineNumber = line;
    this.column = column;
  }
}

Exception.prototype = new Error();

exports['default'] = Exception;
module.exports = exports['default'];
},{}],4:[function(require,module,exports){
(function (global){
'use strict';

exports.__esModule = true;
/*global window */

exports['default'] = function (Handlebars) {
  /* istanbul ignore next */
  var root = typeof global !== 'undefined' ? global : window,
      $Handlebars = root.Handlebars;
  /* istanbul ignore next */
  Handlebars.noConflict = function () {
    if (root.Handlebars === Handlebars) {
      root.Handlebars = $Handlebars;
    }
  };
};

module.exports = exports['default'];
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],5:[function(require,module,exports){
'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports.checkRevision = checkRevision;

// TODO: Remove this line and break up compilePartial

exports.template = template;
exports.wrapProgram = wrapProgram;
exports.resolvePartial = resolvePartial;
exports.invokePartial = invokePartial;
exports.noop = noop;

var _import = require('./utils');

var Utils = _interopRequireWildcard(_import);

var _Exception = require('./exception');

var _Exception2 = _interopRequireWildcard(_Exception);

var _COMPILER_REVISION$REVISION_CHANGES$createFrame = require('./base');

function checkRevision(compilerInfo) {
  var compilerRevision = compilerInfo && compilerInfo[0] || 1,
      currentRevision = _COMPILER_REVISION$REVISION_CHANGES$createFrame.COMPILER_REVISION;

  if (compilerRevision !== currentRevision) {
    if (compilerRevision < currentRevision) {
      var runtimeVersions = _COMPILER_REVISION$REVISION_CHANGES$createFrame.REVISION_CHANGES[currentRevision],
          compilerVersions = _COMPILER_REVISION$REVISION_CHANGES$createFrame.REVISION_CHANGES[compilerRevision];
      throw new _Exception2['default']('Template was precompiled with an older version of Handlebars than the current runtime. ' + 'Please update your precompiler to a newer version (' + runtimeVersions + ') or downgrade your runtime to an older version (' + compilerVersions + ').');
    } else {
      // Use the embedded version info since the runtime doesn't know about this revision yet
      throw new _Exception2['default']('Template was precompiled with a newer version of Handlebars than the current runtime. ' + 'Please update your runtime to a newer version (' + compilerInfo[1] + ').');
    }
  }
}

function template(templateSpec, env) {
  /* istanbul ignore next */
  if (!env) {
    throw new _Exception2['default']('No environment passed to template');
  }
  if (!templateSpec || !templateSpec.main) {
    throw new _Exception2['default']('Unknown template object: ' + typeof templateSpec);
  }

  // Note: Using env.VM references rather than local var references throughout this section to allow
  // for external users to override these as psuedo-supported APIs.
  env.VM.checkRevision(templateSpec.compiler);

  function invokePartialWrapper(partial, context, options) {
    if (options.hash) {
      context = Utils.extend({}, context, options.hash);
    }

    partial = env.VM.resolvePartial.call(this, partial, context, options);
    var result = env.VM.invokePartial.call(this, partial, context, options);

    if (result == null && env.compile) {
      options.partials[options.name] = env.compile(partial, templateSpec.compilerOptions, env);
      result = options.partials[options.name](context, options);
    }
    if (result != null) {
      if (options.indent) {
        var lines = result.split('\n');
        for (var i = 0, l = lines.length; i < l; i++) {
          if (!lines[i] && i + 1 === l) {
            break;
          }

          lines[i] = options.indent + lines[i];
        }
        result = lines.join('\n');
      }
      return result;
    } else {
      throw new _Exception2['default']('The partial ' + options.name + ' could not be compiled when running in runtime-only mode');
    }
  }

  // Just add water
  var container = {
    strict: function strict(obj, name) {
      if (!(name in obj)) {
        throw new _Exception2['default']('"' + name + '" not defined in ' + obj);
      }
      return obj[name];
    },
    lookup: function lookup(depths, name) {
      var len = depths.length;
      for (var i = 0; i < len; i++) {
        if (depths[i] && depths[i][name] != null) {
          return depths[i][name];
        }
      }
    },
    lambda: function lambda(current, context) {
      return typeof current === 'function' ? current.call(context) : current;
    },

    escapeExpression: Utils.escapeExpression,
    invokePartial: invokePartialWrapper,

    fn: function fn(i) {
      return templateSpec[i];
    },

    programs: [],
    program: function program(i, data, declaredBlockParams, blockParams, depths) {
      var programWrapper = this.programs[i],
          fn = this.fn(i);
      if (data || depths || blockParams || declaredBlockParams) {
        programWrapper = wrapProgram(this, i, fn, data, declaredBlockParams, blockParams, depths);
      } else if (!programWrapper) {
        programWrapper = this.programs[i] = wrapProgram(this, i, fn);
      }
      return programWrapper;
    },

    data: function data(value, depth) {
      while (value && depth--) {
        value = value._parent;
      }
      return value;
    },
    merge: function merge(param, common) {
      var obj = param || common;

      if (param && common && param !== common) {
        obj = Utils.extend({}, common, param);
      }

      return obj;
    },

    noop: env.VM.noop,
    compilerInfo: templateSpec.compiler
  };

  function ret(context) {
    var options = arguments[1] === undefined ? {} : arguments[1];

    var data = options.data;

    ret._setup(options);
    if (!options.partial && templateSpec.useData) {
      data = initData(context, data);
    }
    var depths = undefined,
        blockParams = templateSpec.useBlockParams ? [] : undefined;
    if (templateSpec.useDepths) {
      depths = options.depths ? [context].concat(options.depths) : [context];
    }

    return templateSpec.main.call(container, context, container.helpers, container.partials, data, blockParams, depths);
  }
  ret.isTop = true;

  ret._setup = function (options) {
    if (!options.partial) {
      container.helpers = container.merge(options.helpers, env.helpers);

      if (templateSpec.usePartial) {
        container.partials = container.merge(options.partials, env.partials);
      }
    } else {
      container.helpers = options.helpers;
      container.partials = options.partials;
    }
  };

  ret._child = function (i, data, blockParams, depths) {
    if (templateSpec.useBlockParams && !blockParams) {
      throw new _Exception2['default']('must pass block params');
    }
    if (templateSpec.useDepths && !depths) {
      throw new _Exception2['default']('must pass parent depths');
    }

    return wrapProgram(container, i, templateSpec[i], data, 0, blockParams, depths);
  };
  return ret;
}

function wrapProgram(container, i, fn, data, declaredBlockParams, blockParams, depths) {
  function prog(context) {
    var options = arguments[1] === undefined ? {} : arguments[1];

    return fn.call(container, context, container.helpers, container.partials, options.data || data, blockParams && [options.blockParams].concat(blockParams), depths && [context].concat(depths));
  }
  prog.program = i;
  prog.depth = depths ? depths.length : 0;
  prog.blockParams = declaredBlockParams || 0;
  return prog;
}

function resolvePartial(partial, context, options) {
  if (!partial) {
    partial = options.partials[options.name];
  } else if (!partial.call && !options.name) {
    // This is a dynamic partial that returned a string
    options.name = partial;
    partial = options.partials[partial];
  }
  return partial;
}

function invokePartial(partial, context, options) {
  options.partial = true;

  if (partial === undefined) {
    throw new _Exception2['default']('The partial ' + options.name + ' could not be found');
  } else if (partial instanceof Function) {
    return partial(context, options);
  }
}

function noop() {
  return '';
}

function initData(context, data) {
  if (!data || !('root' in data)) {
    data = data ? _COMPILER_REVISION$REVISION_CHANGES$createFrame.createFrame(data) : {};
    data.root = context;
  }
  return data;
}
},{"./base":2,"./exception":3,"./utils":7}],6:[function(require,module,exports){
'use strict';

exports.__esModule = true;
// Build out our basic SafeString type
function SafeString(string) {
  this.string = string;
}

SafeString.prototype.toString = SafeString.prototype.toHTML = function () {
  return '' + this.string;
};

exports['default'] = SafeString;
module.exports = exports['default'];
},{}],7:[function(require,module,exports){
'use strict';

exports.__esModule = true;
exports.extend = extend;

// Older IE versions do not directly support indexOf so we must implement our own, sadly.
exports.indexOf = indexOf;
exports.escapeExpression = escapeExpression;
exports.isEmpty = isEmpty;
exports.blockParams = blockParams;
exports.appendContextPath = appendContextPath;
var escape = {
  '&': '&amp;',
  '<': '&lt;',
  '>': '&gt;',
  '"': '&quot;',
  '\'': '&#x27;',
  '`': '&#x60;'
};

var badChars = /[&<>"'`]/g,
    possible = /[&<>"'`]/;

function escapeChar(chr) {
  return escape[chr];
}

function extend(obj /* , ...source */) {
  for (var i = 1; i < arguments.length; i++) {
    for (var key in arguments[i]) {
      if (Object.prototype.hasOwnProperty.call(arguments[i], key)) {
        obj[key] = arguments[i][key];
      }
    }
  }

  return obj;
}

var toString = Object.prototype.toString;

exports.toString = toString;
// Sourced from lodash
// https://github.com/bestiejs/lodash/blob/master/LICENSE.txt
/*eslint-disable func-style, no-var */
var isFunction = function isFunction(value) {
  return typeof value === 'function';
};
// fallback for older versions of Chrome and Safari
/* istanbul ignore next */
if (isFunction(/x/)) {
  exports.isFunction = isFunction = function (value) {
    return typeof value === 'function' && toString.call(value) === '[object Function]';
  };
}
var isFunction;
exports.isFunction = isFunction;
/*eslint-enable func-style, no-var */

/* istanbul ignore next */
var isArray = Array.isArray || function (value) {
  return value && typeof value === 'object' ? toString.call(value) === '[object Array]' : false;
};exports.isArray = isArray;

function indexOf(array, value) {
  for (var i = 0, len = array.length; i < len; i++) {
    if (array[i] === value) {
      return i;
    }
  }
  return -1;
}

function escapeExpression(string) {
  if (typeof string !== 'string') {
    // don't escape SafeStrings, since they're already safe
    if (string && string.toHTML) {
      return string.toHTML();
    } else if (string == null) {
      return '';
    } else if (!string) {
      return string + '';
    }

    // Force a string conversion as this will be done by the append regardless and
    // the regex test will do this transparently behind the scenes, causing issues if
    // an object's to string has escaped characters in it.
    string = '' + string;
  }

  if (!possible.test(string)) {
    return string;
  }
  return string.replace(badChars, escapeChar);
}

function isEmpty(value) {
  if (!value && value !== 0) {
    return true;
  } else if (isArray(value) && value.length === 0) {
    return true;
  } else {
    return false;
  }
}

function blockParams(params, ids) {
  params.path = ids;
  return params;
}

function appendContextPath(contextPath, id) {
  return (contextPath ? contextPath + '.' : '') + id;
}
},{}],8:[function(require,module,exports){
// Create a simple path alias to allow browserify to resolve
// the runtime on a supported path.
module.exports = require('./dist/cjs/handlebars.runtime')['default'];

},{"./dist/cjs/handlebars.runtime":1}],9:[function(require,module,exports){
module.exports = require("handlebars/runtime")["default"];

},{"handlebars/runtime":8}],10:[function(require,module,exports){
var internal = require("./internal");
var promise = require("./promise");
var onRegisterTimeout;
var whoami;

/**
 * What's the top level module/bundle name.
 * @param moduleQName The module QName. 
 * @returns The module QName, or undefined if unknown.
 */
exports.whoami = function(moduleQName) {
    if (moduleQName) {
        whoami = moduleQName;
        internal.whoami(whoami);
    }
    return whoami;
};

/**
 * Asynchronously import/require a set of modules.
 *
 * <p>
 * Responsible for triggering the async loading of modules if a given module is not already loaded.
 *
 * @param moduleQNames... A list of module "qualified" names, each containing the module name prefixed with the namespace
 * and separated by a colon i.e. "<namespace>:<moduleName>" e.g. "jquery:jquery2".
 *
 * @return A Promise, allowing async load of all modules. The promise is only fulfilled when all modules are loaded.
 */
exports.import = function() {
    if (arguments.length === 1) {
        return internal.import(arguments[0], onRegisterTimeout);        
    }
    
    var moduleQNames = [];    
    for (var i = 0; i < arguments.length; i++) {
        var argument = arguments[i];
        if (typeof argument === 'string') {
            moduleQNames.push(argument);
        }
    }
    
    if (moduleQNames.length == 0) {
        throw "No module names specified.";
    }
    
    return promise.make(function (resolve, reject) {
        var fulfillments = [];
        
        function onFulfillment() {
            if (fulfillments.length === moduleQNames.length) {
                var modules = [];
                for (var i = 0; i < fulfillments.length; i++) {
                    if (fulfillments[i].value) {
                        modules.push(fulfillments[i].value);
                    } else {
                        // don't have everything yet so can't fulfill all.
                        return;
                    }
                }
                // If we make it here, then we have fulfilled all individual promises, which 
                // means we can now fulfill the top level import promise.
                resolve(modules);
            }
        }        
        
        // doRequire for each module
        for (var i = 0; i < moduleQNames.length; i++) {           
            function doRequire(moduleQName) {
                var promise = internal.import(moduleQName, onRegisterTimeout);
                var fulfillment = {
                    promise: promise,
                    value: undefined
                };
                fulfillments.push(fulfillment);
                promise
                    .onFulfilled(function(value) {
                        fulfillment.value = value;
                        onFulfillment();
                    })
                    .onRejected(function(error) {
                        reject(error);
                    });
            }
            doRequire(moduleQNames[i]);
        }
    }).applyArgsOnFulfill();    
};

/**
 * Synchronously "require" a module that it already loaded/registered.
 *
 * <p>
 * This function will throw an error if the module is not already loaded via an outer call to 'import'
 * (or 'import').
 *
 * @param moduleQName The module "qualified" name containing the module name prefixed with the namespace
 * separated by a colon i.e. "<namespace>:<moduleName>" e.g. "jquery:jquery2".
 *
 * @return The module.
 */
exports.require = function(moduleQName) {
    var parsedModuleName = internal.parseResourceQName(moduleQName);
    var module = internal.getModule(parsedModuleName);    
    if (!module) {
        throw "Unable to perform synchronous 'require' for module '" + moduleQName + "'. This module is not pre-loaded. " +
            "The module needs to have been asynchronously pre-loaded via an outer call to 'import'.";
    }
    return module.exports;
}

/**
 * Export a module.
 * 
 * @param namespace The namespace in which the module resides, or "undefined" if the modules is in
 * the "global" module namespace e.g. a Jenkins core bundle.
 * @param moduleName The name of the module. 
 * @param module The CommonJS style module, or "undefined" if we just want to notify other modules waiting on
 * the loading of this module.
 * @param onError On error callback;
 */
exports.export = function(namespace, moduleName, module, onError) {
    internal.onReady(function() {
        try {
            var moduleSpec = {namespace: namespace, moduleName: moduleName};
            var moduleNamespaceObj = internal.getModuleNamespaceObj(moduleSpec);
            
            if (moduleNamespaceObj[moduleName]) {
                if (namespace) {
                    throw "Jenkins plugin module '" + namespace + ":" + moduleName + "' already registered.";
                } else {
                    throw "Jenkins global module '" + moduleName + "' already registered.";
                }
            }
            
            if (!module) {
                module = {
                    exports: {}
                };
            } else if (module.exports === undefined) {
                module = {
                    exports: module
                };
            }
            moduleNamespaceObj[moduleName] = module;
            
            // Notify all that the module has been registered. See internal.loadModule also.
            internal.notifyModuleExported(moduleSpec, module.exports);
        } catch (e) {
            console.error(e);
            if (onError) {
                onError(e);
            }
        }
    });
};

/**
 * Add a module's CSS to the browser page.
 * 
 * <p>
 * The assumption is that the CSS can be accessed at e.g.
 * {@code <rootURL>/plugin/<namespace>/jsmodules/<moduleName>/style.css} i.e.
 * the pluginId acts as the namespace.
 * 
 * @param namespace The namespace in which the module resides.
 * @param moduleName The name of the module. 
 * @param onError On error callback;
 */
exports.addModuleCSSToPage = function(namespace, moduleName, onError) {
    internal.onReady(function() {
        try {
            internal.addModuleCSSToPage(namespace, moduleName);
        } catch (e) {
            console.error(e);
            if (onError) {
                onError(e);
            }
        }
    });
};

/**
 * Add a plugin CSS file to the browser page.
 * 
 * @param pluginName The Jenkins plugin in which the module resides.
 * @param moduleName The name of the module. 
 * @param onError On error callback;
 */
exports.addPluginCSSToPage = function(pluginName, cssPath, onError) {
    internal.onReady(function() {
        try {
            internal.addPluginCSSToPage(pluginName, cssPath);
        } catch (e) {
            console.error(e);
            if (onError) {
                onError(e);
            }
        }
    });
};

/**
 * Add a javascript &lt;script&gt; element to the document &lt;head&gt;.
 * <p/>
 * Options:
 * <ul>
 *     <li><strong>scriptId</strong>: The script Id to use for the element. If not specified, one will be generated from the scriptSrc.</li>
 *     <li><strong>async</strong>: Asynchronous loading of the script. Default is 'true'.</li>
 *     <li><strong>success</strong>: An optional onload success function for the script element.</li>
 *     <li><strong>error</strong>: An optional onload error function for the script element. This is called if the .js file exists but there's an error evaluating the script. It is NOT called if the .js file doesn't exist (ala 404).</li>
 *     <li><strong>removeElementOnLoad</strong>: Remove the script element after loading the script. Default is 'false'.</li>
 * </ul>
 * 
 * @param scriptSrc The script src.
 * @param options Optional script load options object. See above.
 */
exports.addScript = function(scriptSrc, options) {
    internal.onReady(function() {
        internal.addScript(scriptSrc, options);
    });    
};

/**
 * Set the module registration timeout i.e. the length of time to wait for a module to load before failing.
 *
 * @param timeout Millisecond duration before onRegister times out. Defaults to 10000 (10s) if not specified.
 */
exports.setRegisterTimeout = function(timeout) {
    onRegisterTimeout = timeout;
}

/**
 * Set the Jenkins root/base URL.
 * 
 * @param rootUrl The root/base URL.
 */
exports.setRootURL = function(rootUrl) {
    internal.setRootURL(rootUrl);
};

/**
 * Manually initialise the Jenkins Global.
 * <p>
 * This should only ever be called from a test environment.
 */
exports.initJenkinsGlobal = function() {
    internal.initJenkinsGlobal();
};

internal.onJenkinsGlobalInit(function(jenkinsCIGlobal) {
    // For backward compatibility, we need to make some jenkins-js-modules
    // functions globally available e.g. to allow legacy code wait for
    // certain modules to be loaded, as with legacy adjuncts.
    if (!jenkinsCIGlobal._internal) {
        // Put the functions on an object called '_internal' as a way
        // of hinting to people to not use it.
        jenkinsCIGlobal._internal = {
            import: exports.import,
            addScript: internal.addScript
        };
    }
});
},{"./internal":11,"./promise":12}],11:[function(require,module,exports){
var promise = require("./promise");
var windowHandle = require("window-handle");
var jenkinsCIGlobal;
var globalInitListeners = [];
var whoami;

exports.whoami = function(moduleQName) {
    if (moduleQName) {
        whoami = exports.parseResourceQName(moduleQName);
        whoami.nsProvider = getBundleNSProviderFromScriptElement(whoami.namespace, whoami.moduleName);
    }
    return whoami;
};

exports.onReady = function(callback) {
    // This allows test based initialization of jenkins-js-modules when there might 
    // not yet be a global window object.
    if (jenkinsCIGlobal) {
        callback();
    } else {
        windowHandle.getWindow(function() {
            callback();
        });
    }    
};

exports.onJenkinsGlobalInit = function(callback) {
    globalInitListeners.push(callback);
};

exports.initJenkinsGlobal = function() {
    jenkinsCIGlobal = {
    };
    if (globalInitListeners) {
        for (var i = 0; i < globalInitListeners.length; i++) {
            globalInitListeners[i](jenkinsCIGlobal);
        }
    }
};

exports.clearJenkinsGlobal = function() {    
    jenkinsCIGlobal = undefined;
    whoami = undefined;
};

exports.getJenkins = function() {
    if (jenkinsCIGlobal) {
        return jenkinsCIGlobal;
    }
    var window = windowHandle.getWindow();
    if (window.jenkinsCIGlobal) {
        jenkinsCIGlobal = window.jenkinsCIGlobal;
    } else {
        exports.initJenkinsGlobal();
        jenkinsCIGlobal.rootURL = getRootURL();
        window.jenkinsCIGlobal = jenkinsCIGlobal;
    }   
    return jenkinsCIGlobal;
};

exports.getModuleNamespaceObj = function(moduleSpec) {
    if (moduleSpec.namespace) {
        return exports.getNamespace(moduleSpec.namespace);
    } else {
        return exports.getGlobalModules();
    }
}

exports.getNamespace = function(namespaceName) {
    var namespaces = exports.getNamespaces();
    var namespace = namespaces[namespaceName];
    if (!namespace) {
        namespace = {
            globalNS: false            
        };
        namespaces[namespaceName] = namespace;
    }
    return namespace;
};

exports.import = function(moduleQName, onRegisterTimeout) {
    return promise.make(function (resolve, reject) {
        // Some functions here needs to access the 'window' global. We want to make sure that
        // exists before attempting to fulfill the require operation. It may not exists
        // immediately in a test env.
        exports.onReady(function() {
            var moduleSpec = exports.parseResourceQName(moduleQName);
            var module = exports.getModule(moduleSpec);
            
            if (module) {
                // module already loaded
                resolve(module.exports);
            } else {
                if (onRegisterTimeout === 0) {
                    if (moduleSpec.namespace) {
                        throw 'Module ' + moduleSpec.namespace + ':' + moduleSpec.moduleName + ' require failure. Async load mode disabled.';
                    } else {
                        throw 'Global module ' + moduleSpec.moduleName + ' require failure. Async load mode disabled.';
                    }
                }

                // module not loaded. Load async, fulfilling promise once registered
                exports.loadModule(moduleSpec, onRegisterTimeout)
                    .onFulfilled(function (moduleExports) {
                        resolve(moduleExports);
                    })
                    .onRejected(function (error) {
                        reject(error);
                    });
            }
        });
    });    
};

exports.loadModule = function(moduleSpec, onRegisterTimeout) {
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);
    var module = moduleNamespaceObj[moduleSpec.moduleName];
    
    if (module) {
        // Module already loaded. This prob shouldn't happen.
        console.log("Unexpected call to 'loadModule' for a module (" + moduleSpec.moduleName + ") that's already loaded.");
        return promise.make(function (resolve) {
            resolve(module.exports);
        });
    }

    function waitForRegistration(loadingModule, onRegisterTimeout) {
        return promise.make(function (resolve, reject) {
            if (typeof onRegisterTimeout !== "number") {
                onRegisterTimeout = 10000;
            }
            
            var timeoutObj = setTimeout(function () {
                // Timed out waiting on the module to load and register itself.
                if (!loadingModule.loaded) {
                    var moduleSpec = loadingModule.moduleSpec;
                    var errorDetail;
                    
                    if (moduleSpec.namespace) {
                        errorDetail = "Timed out waiting on module '" + moduleSpec.namespace + ":" + moduleSpec.moduleName + "' to load.";
                    } else {
                        errorDetail = "Timed out waiting on global module '" + moduleSpec.moduleName + "' to load.";
                    }                    
                    console.error('Module load failure: ' + errorDetail);

                    // Call the reject function and tell it we timed out
                    reject({
                        reason: 'timeout',
                        detail: errorDetail
                    });
                }
            }, onRegisterTimeout);
            
            loadingModule.waitList.push({
                resolve: resolve,
                timeoutObj: timeoutObj
            });                    
        });
    }
    
    var loadingModule = getLoadingModule(moduleNamespaceObj, moduleSpec.moduleName);
    if (!loadingModule.waitList) {
        loadingModule.waitList = [];
    }
    loadingModule.moduleSpec = moduleSpec; 
    loadingModule.loaded = false;

    try {
        return waitForRegistration(loadingModule, onRegisterTimeout);
    } finally {
        // We can auto/dynamic load modules in a non-global namespace. Global namespace modules
        // need to make sure they load themselves (via an adjunct, or whatever).
        if (moduleSpec.namespace) {
            var scriptId = exports.toModuleId(moduleSpec.namespace, moduleSpec.moduleName) + ':js';
            var scriptSrc = exports.toModuleSrc(moduleSpec, 'js');            
            var scriptEl = exports.addScript(scriptSrc, {
                scriptId: scriptId,
                scriptSrcBase: ''
            });

            if (scriptEl) {
                // Set the module spec info on the <script> element. This allows us to resolve the
                // nsProvider for that bundle after 'whoami' is called for it (as it loads). whoami
                // is not called with the nsProvider info on it because a given bundle can 
                // potentially be loaded from multiple different ns providers, so we only resole the provider
                // at load-time i.e. just after a bundle is loaded it calls 'whoami' for itself
                // and then this module magically works out where it was loaded from (it's nsProvider)
                // by locating the <script> element and using this information. For a module/bundle, knowing
                // where it was loaded from is important because it dictates where that module/bundle
                // should load it dependencies from. For example, the Bootstrap module/bundle depends on the
                // jQuery bundle. So, if the bootstrap bundle is loaded from the 'core-assets' namespace provider,
                // then that means the jQuery bundle should also be loaded from the 'core-assets'
                // namespace provider.
                // See getBundleNSProviderFromScriptElement.
                scriptEl.setAttribute('data-jenkins-module-nsProvider', moduleSpec.nsProvider);
                scriptEl.setAttribute('data-jenkins-module-namespace', moduleSpec.namespace);
                scriptEl.setAttribute('data-jenkins-module-moduleName', moduleSpec.moduleName);
            }
        }
    }
};

exports.addScript = function(scriptSrc, options) {
    if (!scriptSrc) {
        console.warn('Call to addScript with undefined "scriptSrc" arg.');
        return undefined;
    }    
    
    var normalizedOptions;
    
    // If there's no options object, create it.
    if (typeof options === 'object') {
        normalizedOptions = options;
    } else {
        normalizedOptions = {};
    }
    
    // May want to transform/map some urls.
    if (normalizedOptions.scriptSrcMap) {
        if (typeof normalizedOptions.scriptSrcMap === 'function') {
            scriptSrc = normalizedOptions.scriptSrcMap(scriptSrc);
        } else if (Array.isArray(normalizedOptions.scriptSrcMap)) {
            // it's an array of suffix mappings
            for (var i = 0; i < normalizedOptions.scriptSrcMap.length; i++) {
                var mapping = normalizedOptions.scriptSrcMap[i];
                if (mapping.from && mapping.to) {
                    if (endsWith(scriptSrc, mapping.from)) {
                        normalizedOptions.originalScriptSrc = scriptSrc;
                        scriptSrc = scriptSrc.replace(mapping.from, mapping.to);
                        break;
                    }
                }
            }
        }
    }
    
    normalizedOptions.scriptId = getScriptId(scriptSrc, options);
    
    // set some default options
    if (normalizedOptions.async === undefined) {
        normalizedOptions.async = true;
    }
    if (normalizedOptions.scriptSrcBase === undefined) {
        normalizedOptions.scriptSrcBase = getRootURL() + '/';
    }

    var document = windowHandle.getWindow().document;
    var head = exports.getHeadElement();
    var script = document.getElementById(normalizedOptions.scriptId);

    if (script) {
        var replaceable = script.getAttribute('data-replaceable');
        if (replaceable && replaceable === 'true') {
            // This <script> element is replaceable. In this case, 
            // we remove the existing script element and add a new one of the
            // same id and with the specified src attribute.
            // Adding happens below.
            script.parentNode.removeChild(script);
        } else {
            return undefined;
        }
    }

    script = createElement('script');

    // Parts of the following onload code were inspired by how the ACE editor does it,
    // as well as from the follow SO post: http://stackoverflow.com/a/4845802/1166986
    var onload = function (_, isAborted) {
        script.setAttribute('data-onload-complete', true);
        try {
            if (isAborted) {
                console.warn('Script load aborted: ' + scriptSrc);
            } else if (!script.readyState || script.readyState === "loaded" || script.readyState === "complete") {
                // If the options contains an onload function, call it.
                if (typeof normalizedOptions.success === 'function') {
                    normalizedOptions.success(script);
                }
                return;
            }
            if (typeof normalizedOptions.error === 'function') {
                normalizedOptions.error(script, isAborted);
            }
        } finally {
            if (normalizedOptions.removeElementOnLoad) {
                head.removeChild(script);
            }
            // Handle memory leak in IE
            script = script.onload = script.onreadystatechange = null;
        }
    };
    script.onload = onload; 
    script.onreadystatechange = onload;

    script.setAttribute('id', normalizedOptions.scriptId);
    script.setAttribute('type', 'text/javascript');
    script.setAttribute('src', normalizedOptions.scriptSrcBase + scriptSrc);
    if (normalizedOptions.originalScriptSrc) {
        script.setAttribute('data-referrer', normalizedOptions.originalScriptSrc);        
    }
    if (normalizedOptions.async) {
        script.setAttribute('async', normalizedOptions.async);
    }
    
    head.appendChild(script);
    
    return script;
};

exports.notifyModuleExported = function(moduleSpec, moduleExports) {
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);
    var loadingModule = getLoadingModule(moduleNamespaceObj, moduleSpec.moduleName);
    
    loadingModule.loaded = true;
    if (loadingModule.waitList) {
        for (var i = 0; i < loadingModule.waitList.length; i++) {
            var waiter = loadingModule.waitList[i];
            clearTimeout(waiter.timeoutObj);
            waiter.resolve(moduleExports);
        }
    }    
};

exports.addModuleCSSToPage = function(namespace, moduleName) {
    var moduleSpec = exports.getModuleSpec(namespace + ':' + moduleName);
    var cssElId = exports.toModuleId(namespace, moduleName) + ':css';
    var cssPath = exports.toModuleSrc(moduleSpec, 'css');
    return exports.addCSSToPage(namespace, cssPath, cssElId);
};

exports.addPluginCSSToPage = function(namespace, cssPath, cssElId) {
    var cssPath = exports.getPluginPath(namespace) + '/' + cssPath;
    return exports.addCSSToPage(namespace, cssPath, cssElId);
};

exports.addCSSToPage = function(namespace, cssPath, cssElId) {
    var document = windowHandle.getWindow().document;
    
    if (cssElId === undefined) {
        cssElId = 'jenkins-js-module:' + namespace + ':' + ':css:' + cssPath;
    }
    
    var cssEl = document.getElementById(cssElId);
    
    if (cssEl) {
        // already added to page
        return;
    }

    var docHead = exports.getHeadElement();
    cssEl = createElement('link');
    cssEl.setAttribute('id', cssElId);
    cssEl.setAttribute('type', 'text/css');
    cssEl.setAttribute('rel', 'stylesheet');
    cssEl.setAttribute('href', cssPath);
    docHead.appendChild(cssEl);
    
    return cssEl;
};

exports.getGlobalModules = function() {
    var jenkinsCIGlobal = exports.getJenkins();
    if (!jenkinsCIGlobal.globals) {
        jenkinsCIGlobal.globals = {
            globalNS: true
        };
    }
    return jenkinsCIGlobal.globals;
};

exports.getNamespaces = function() {
    var jenkinsCIGlobal = exports.getJenkins();
    
    // The namespaces are stored in an object named "plugins". This is a legacy from the
    // time when all modules lived in plugins. By right we'd like to rename this, but
    // that would cause compatibility issues.
    
    if (!jenkinsCIGlobal.plugins) {
        jenkinsCIGlobal.plugins = {
            __README__: 'This object holds namespaced JS modules/bundles, with the property names representing the module namespace. It\'s name ("plugins") is a legacy thing. Changing it to a better name (e.g. "namespaces") would cause compatibility issues.'
        };
    }
    return jenkinsCIGlobal.plugins;
};

exports.toModuleId = function(namespace, moduleName) {
    return 'jenkins-js-module:' + namespace + ':' + moduleName;
};

exports.toModuleSrc = function(moduleSpec, srcType) {
    var nsProvider = moduleSpec.nsProvider;
    
    // If a moduleSpec on a module/bundle import doesn't specify a namespace provider
    // (i.e. is of the form "a:b" and not "core-assets/a:b"),
    // then check "this" bundles module spec and see if it was imported from a specific
    // namespace. If it was (e.g. 'core-assets'), then import from that namespace.
    if (nsProvider === undefined) {
        nsProvider = thisBundleNamespaceProvider();
        if (nsProvider === undefined) {
            nsProvider = 'plugin';
        }
        // Store the nsProvider back onto the moduleSpec.
        moduleSpec.nsProvider = nsProvider;
    }
    
    var srcPath = undefined;
    if (srcType === 'js') {
        srcPath = moduleSpec.moduleName + '.js';
    } else if (srcType === 'css') {
        srcPath = moduleSpec.moduleName + '/style.css';
    } else {
        throw 'Unsupported srcType "'+ srcType + '".';
    }
    
    if (nsProvider === 'plugin') {
        return exports.getPluginJSModulesPath(moduleSpec.namespace) + '/' + srcPath;
    } if (nsProvider === 'core-assets') {
        return exports.getCoreAssetsJSModulesPath(moduleSpec.namespace) + '/' + srcPath;
    } else {
        throw 'Unsupported namespace provider: ' + nsProvider;
    }
};

exports.getPluginJSModulesPath = function(pluginId) {
    return exports.getPluginPath(pluginId) + '/jsmodules';
};

exports.getCoreAssetsJSModulesPath = function(namespace) {
    return getRootURL() + '/assets/' + namespace + '/jsmodules';
};

exports.getPluginPath = function(pluginId) {
    return getRootURL() + '/plugin/' + pluginId;
};

exports.getHeadElement = function() {
    var window = windowHandle.getWindow();
    var docHead = window.document.getElementsByTagName("head");
    if (!docHead || docHead.length == 0) {
        throw 'No head element found in document.';
    }
    return docHead[0];
};

exports.setRootURL = function(url) {    
    if (!jenkinsCIGlobal) {
        exports.initJenkinsGlobal();
    }
    jenkinsCIGlobal.rootURL = url;
};

exports.parseResourceQName = function(resourceQName) {
    var qNameTokens = resourceQName.split(":");    
    if (qNameTokens.length === 2) {
        var namespace = qNameTokens[0].trim();
        var nsTokens = namespace.split("/");
        var namespaceProvider = undefined;
        if (nsTokens.length === 2) {
            namespaceProvider = nsTokens[0].trim();
            namespace = nsTokens[1].trim();
            if (namespaceProvider !== 'plugin' && namespaceProvider !== 'core-assets') {
                console.error('Unsupported module namespace provider "' + namespaceProvider + '". Setting to undefined.');
                namespaceProvider = undefined;
            }
        }
        return {
            nsProvider: namespaceProvider,
            namespace: namespace,
            moduleName: qNameTokens[1].trim()
        };
    } else {
        // The module/bundle is not in a namespace and doesn't
        // need to be loaded i.e. it will load itself and export.
        return {
            moduleName: qNameTokens[0].trim()
        };
    }
};

exports.getModule = function(moduleSpec) {
    if (moduleSpec.namespace) {
        var plugin = exports.getNamespace(moduleSpec.namespace);
        return plugin[moduleSpec.moduleName];
    } else {
        var globals = exports.getGlobalModules();
        return globals[moduleSpec.moduleName];
    }
};

exports.getModuleSpec = function(moduleQName) {
    var moduleSpec = exports.parseResourceQName(moduleQName);
    var moduleNamespaceObj = exports.getModuleNamespaceObj(moduleSpec);    
    if (moduleNamespaceObj) {
        var loading = getLoadingModule(moduleNamespaceObj, moduleSpec.moduleName);
        if (loading && loading.moduleSpec) {
            return loading.moduleSpec;
        }
    }
    return moduleSpec;
};

function getScriptId(scriptSrc, config) {
    if (typeof config === 'string') {
        return config;
    } else if (typeof config === 'object' && config.scriptId) {
        return config.scriptId;
    } else {
        return 'jenkins-script:' + scriptSrc;
    }    
}

function getRootURL() {
    if (jenkinsCIGlobal && jenkinsCIGlobal.rootURL) {
        return jenkinsCIGlobal.rootURL;
    }
    
    var docHead = exports.getHeadElement();
    var resURL = getAttribute(docHead, "resURL");

    if (!resURL) {
        throw "Attribute 'resURL' not defined on the document <head> element.";
    }

    if (jenkinsCIGlobal) {
        jenkinsCIGlobal.rootURL = resURL;
    }
    
    return resURL;
}

function createElement(name) {
    var document = windowHandle.getWindow().document;
    return document.createElement(name);
}

function getAttribute(element, attributeName) {
    var value = element.getAttribute(attributeName.toLowerCase());
    
    if (value) {
        return value;
    } else {
        // try without lowercasing
        return element.getAttribute(attributeName);
    }    
}

function getLoadingModule(moduleNamespaceObj, moduleName) {
    if (!moduleNamespaceObj.loadingModules) {
        moduleNamespaceObj.loadingModules = {};
    }
    if (!moduleNamespaceObj.loadingModules[moduleName]) {
        moduleNamespaceObj.loadingModules[moduleName] = {};
    }
    return moduleNamespaceObj.loadingModules[moduleName];
}

function endsWith(string, suffix) {
    return (string.indexOf(suffix, string.length - suffix.length) !== -1);
}

function thisBundleNamespaceProvider() {        
    if (whoami !== undefined) {
        return whoami.nsProvider;
    }
    return undefined;
}

function getBundleNSProviderFromScriptElement(namespace, moduleName) {
    var docHead = exports.getHeadElement();
    var scripts = docHead.getElementsByTagName("script");

    for (var i = 0; i < scripts.length; i++) {
        var script = scripts[i];
        var elNamespace = script.getAttribute('data-jenkins-module-namespace');
        var elModuleName = script.getAttribute('data-jenkins-module-moduleName');
        
        if (elNamespace === namespace && elModuleName === moduleName) {
            return script.getAttribute('data-jenkins-module-nsProvider');
        }
    }
    
    return undefined;
}

},{"./promise":12,"window-handle":13}],12:[function(require,module,exports){
/*
 * Very simple "Promise" impl.
 * <p>
 * Intentionally not using the "promise" module/polyfill because it will add a few Kb and we 
 * only need something very simple here. We really just want to follow the main pattern
 * and don't need some of the fancy stuff.
 * <p>
 * I think so long as we stick to same interface/interaction pattern as outlined in the link
 * below, then we can always switch to the "promise" module later without breaking anything.
 * <p>
 * See https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Promise
 */

exports.make = function(executor) {
    var thePromise = new APromise();
    executor.call(thePromise, function(result) {
        thePromise.resolve(result);
    }, function(reason) {
        thePromise.reject(reason);
    });
    return thePromise;
};

function APromise() {
    this.state = 'PENDING';
    this.whenFulfilled = undefined;
    this.whenRejected = undefined;
    this.applyFulfillArgs = false;
}

APromise.prototype.applyArgsOnFulfill = function() {
    this.applyFulfillArgs = true;
    return this;
}

APromise.prototype.resolve = function (result) {
    this.state = 'FULFILLED';
    
    var thePromise = this;
    function doFulfill(whenFulfilled, result) {
        if (thePromise.applyFulfillArgs) {
            whenFulfilled.apply(whenFulfilled, result);
        } else {
            whenFulfilled(result);
        }
    }
    
    if (this.whenFulfilled) {
        doFulfill(this.whenFulfilled, result);
    }
    // redefine "onFulfilled" to call immediately
    this.onFulfilled = function (whenFulfilled) {
        if (whenFulfilled) {
            doFulfill(whenFulfilled, result);
        }
        return this;
    }
};

APromise.prototype.reject = function (reason) {
    this.state = 'REJECTED';
    if (this.whenRejected) {
        this.whenRejected(reason);
    }
    // redefine "onRejected" to call immediately
    this.onRejected = function(whenRejected) {
        if (whenRejected) {
            whenRejected(reason);
        }
        return this;
    }
};

APromise.prototype.onFulfilled = function(whenFulfilled) {
    if (!whenFulfilled) {
        throw 'Must provide an "whenFulfilled" callback.';
    }
    this.whenFulfilled = whenFulfilled;
    return this;
};

APromise.prototype.onRejected = function(whenRejected) {        
    if (whenRejected) {
        this.whenRejected = whenRejected;
    }
    return this;
};

},{}],13:[function(require,module,exports){
var theWindow;
var defaultTimeout = 10000;
var callbacks = [];
var windowSetTimeouts = [];

function execCallback(callback, theWindow) {
    if (callback) {
        try {
            callback.call(callback, theWindow);                
        } catch (e) {
            console.log("Error invoking window-handle callback.");
            console.log(e);
        }
    }
}

/**
 * Get the global "window" object.
 * @param callback An optional callback that can be used to receive the window asynchronously. Useful when
 * executing in test environment i.e. where the global window object might not exist immediately. 
 * @param timeout The timeout if waiting on the global window to be initialised.
 * @returns {*}
 */
exports.getWindow = function(callback, timeout) {
    
	if (theWindow) {
        execCallback(callback, theWindow);
        return theWindow;
	} 
	
	try {
		if (window) {
            execCallback(callback, window);
			return window;
		} 
	} catch (e) {
		// no window "yet". This should only ever be the case in a test env.
		// Fall through and use callbacks, if supplied.
	}

	if (callback) {
        function waitForWindow(callback) {
            callbacks.push(callback);
            var windowSetTimeout = setTimeout(function() {
                callback.error = "Timed out waiting on the window to be set.";
                callback.call(callback);
            }, (timeout?timeout:defaultTimeout));
            windowSetTimeouts.push(windowSetTimeout);
        }
        waitForWindow(callback);
	} else {
		throw "No 'window' available. Consider providing a 'callback' and receiving the 'window' async when available. Typically, this should only be the case in a test environment.";
	}
}

/**
 * Set the global window e.g. in a test environment.
 * <p>
 * Once called, all callbacks (registered by earlier 'getWindow' calls) will be invoked.
 * 
 * @param newWindow The window.
 */
exports.setWindow = function(newWindow) {
	for (var i = 0; i < windowSetTimeouts.length; i++) {
		clearTimeout(windowSetTimeouts[i]);
	}
    windowSetTimeouts = [];
	theWindow = newWindow;
	for (var i = 0; i < callbacks.length; i++) {
		execCallback(callbacks[i], theWindow);
	}
    callbacks = [];
}

/**
 * Set the default time to wait for the global window to be set.
 * <p>
 * Default is 10 seconds (10000 ms).
 * 
 * @param millis Milliseconds to wait for the global window to be set.
 */
exports.setDefaultTimeout = function(millis) {
    defaultTimeout = millis;
}
},{}],14:[function(require,module,exports){
/**
 * Pipeline editor main module. Dreaming of Alaskan pipelines 4 eva. 
 *  Elements that are to be used when actually editing should have a class of 'edit-mode'.
 *  Then we can support read only by simply $('.edit-mode').hide();
 * 
 * I Recommended that you understand the stage/step/parallel/node concepts in workflow well before looking further.
 * "Normal stage" means a normal workflow stage. A "parallel stage" is just a stage that 
 *  has a parallel set of streams (sometimes called branches) under it, as is the workflow convention.
 */

var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();
var lines = require('./svg/lines');

var stringify = require('./model/stringify');
var wf = require('./model/workflow');

var steps = require('./steps');

/**
 * Draw the pipeline visualisation based on the pipeline data, including svg.
 * Current pipeline is stored in the "pipeline" variable assumed to be in scope. 
 * Also requires formFields of script and json
 */
exports.drawPipeline = function (pipeline, formFields) {  
  var pRow = $('#pipeline-row');
  pRow.empty();
  
  for (var i=0; i < pipeline.length; i++) {
    var stage = pipeline[i];
    var currentId = "stage-" + i;      
    //append a block if non parallel
    if (!wf.isParallelStage(stage)) {      
      pRow.append(normalStageBlock(currentId, stage));
    } else {      
      var subStages = "";
      for (var j = 0; j < stage.streams.length; j++) {
        var subStage = stage.streams[j];
        var subStageId = currentId + "-" + j;                
        subStages += parStageBlock(stage.name, subStageId, subStage, currentId);
      }      
      
      pRow.append(parallelStack(subStages, currentId)); 
    }
  }
  pRow.append(addStageButton());
  
  addNewStageListener(pipeline, formFields);
  addNewStreamListener(pipeline, formFields);
  
  lines.autoJoinDelay(pipeline);  
  addAutoJoinHooks(pipeline);

  addOpenStepListener(pipeline, formFields);
  addNewStepListener(pipeline, formFields);
  
  addConfigStageListener(pipeline, formFields);
  addConfigStreamListener(pipeline, formFields);
  
};

/** redraw the pipeline and apply changes to the formFields in the Jenksin config page */
function redrawPipeline(pipeline, formFields) {
  exports.drawPipeline(pipeline, formFields);           
  writeOutChanges(pipeline, formFields);              
}

/** a parallel stage is really just a stage, but with a stack of parallel streams (each which have a name) */
function parallelStack(subStages, currentId) {
  return require('./templates/parallel-stack.hbs')({subStages: subStages, addStreamButton : addStreamButton(currentId), currentId : currentId });
}

/** This will add a plain stage to the end of the set of stages */
function addStageButton() {    
  return require('./templates/stage-button.hbs')();
}

/** A stream is a named part of a parallel block in workflow */
function addStreamButton(stageId) {
  return require('./templates/stream-button.hbs')({stageId: stageId});
}

/** show a popover for changing stage level settings, or deleting */
function addConfigStageListener(pipeline, formFields) {
  $("#pipeline-visual-editor").on('click', ".open-stage-config", function() {
      var stageId = $( this ).attr('data-stage-id');
      var coords = wf.stageIdToCoordinates(stageId);
      var currentStage = pipeline[coords[0]];
      
      var stageConfigP = $("#edit-stage-popover-" + stageId);
      var popContent = require('./templates/stage-config-block.hbs')({stageId: stageId, stageName: currentStage.name});
      stageConfigP.popover({'content' : popContent, 'html' : true});
      stageConfigP.popover('show');
      $('#toggleParallel-' + stageId).off('click').click(function() {
        wf.toggleParallel(pipeline, stageId);
        redrawPipeline(pipeline, formFields);
        stageConfigP.popover('destroy');
      });
      $('#closeStageConfig-' + stageId).off('click').click(function () {
        var newName = $('#stageName_' + stageId).val();        
        if (newName !== currentStage.name) {
          currentStage.name = newName;
          redrawPipeline(pipeline, formFields);
        } 
        stageConfigP.popover('destroy');
      });
      $('#deleteStage-' + stageId).off('click').click(function() {
        if (window.confirm("Are you sure you want to delete this stage?")) {
          wf.removeStage(pipeline, stageId);
          redrawPipeline(pipeline, formFields);
          stageConfigP.popover('destroy');
        }
      });
      
      
  });
}

/** popover for changing stream settings for a parallel stage, including deleting */
function addConfigStreamListener(pipeline, formFields) {
  $("#pipeline-visual-editor").on('click', ".open-stream-config", function() {
      var stageId = $( this ).attr('data-stage-id');
      var streamId = $( this ).attr('data-stream-id');
      var coords = wf.stageIdToCoordinates(streamId);
      var currentStage = pipeline[coords[0]];
      var currentStream = currentStage.streams[coords[1]];
      
      console.log(stageId);
      var streamConfigP = $("#edit-stage-popover-" + streamId);
      var popContent = require('./templates/stream-config-block.hbs')(
          { stageId: stageId, 
            streamId: streamId, 
            stageName: currentStage.name,
            streamName: currentStage.streams[coords[1]].name
          });
      streamConfigP.popover({'content' : popContent, 'html' : true});
      streamConfigP.popover('show');
      
      $('#makeSequential-' + stageId).off('click').click(function() {
        wf.parallelToNormal(pipeline, stageId);
        redrawPipeline(pipeline, formFields);
        streamConfigP.popover('destroy');
      });
      
      $('#closeStageConfig-' + stageId).off('click').click(function () {
        var newName = $('#stageName_' + stageId).val();        
        var newStreamName = $('#streamName_' + streamId).val();        
        if (newName !== currentStage.name || newStreamName !== currentStream.name) {
          currentStage.name = newName;
          currentStream.name = newStreamName;
          redrawPipeline(pipeline, formFields);
        } 
        streamConfigP.popover('destroy');
      });
      
      $('#deleteStage-' + stageId).off('click').click(function() {
        if (window.confirm("Are you sure you want to delete the whole stage and all its parallel branches?")) {
          wf.removeStage(pipeline, stageId);
          redrawPipeline(pipeline, formFields);
          streamConfigP.popover('destroy');
        }
      });
      
      $('#deleteStream-' + streamId).off('click').click(function() {
        if (window.confirm("Are you sure you want to delete branch?")) {
          wf.removeStage(pipeline, streamId);
          redrawPipeline(pipeline, formFields);
          streamConfigP.popover('destroy');
        }
      });

      
      
  });
}


/** add a new stream (sometimes called a branch) to the end of the list of streams in a stage */
function addNewStreamListener(pipeline) {
  $("#pipeline-visual-editor").on('click', ".open-add-stream", function(){
    var stageId = $( this ).attr('data-stage-id');
    var newStreamP = $('#add-stream-popover-' + stageId);
    var newStreamBlock = require('./templates/stream-block.hbs')({stageId: stageId});
    newStreamP.popover({'content' : newStreamBlock, 'html' : true});
    newStreamP.popover('show');      
    $('#addStreamBtn-' + stageId).off('click').click(function() {
        handleAddStream(newStreamP, stageId, pipeline);
    });      
    $("#newStreamName-" + stageId).off('keydown').keydown(function (e) {
      if (e.which === 13) {
        handleAddStream(newStreamP, stageId, pipeline);
      }
    });
    $("#newStreamName-" + stageId).focus();
  });  
  
}


/** add a new stream to an existing stage and redraw just that section */
function handleAddStream(newStreamP, stageId, pipeline) {
  newStreamP.popover('toggle');
  var newStreamName = $("#newStreamName-" + stageId).val();
  if (newStreamName !== '') {
    var coords = wf.stageIdToCoordinates(stageId);
    var outerStage = pipeline[coords[0]];
    var newStream = {"name": newStreamName, "steps": []};
    outerStage.streams.push(newStream);
    // Insert the new stream stage directly into the DOM...
    var subStageId = stageId + "-" + (outerStage.streams.length - 1);
    var streamView = parStageBlock(outerStage.name, subStageId, newStream, stageId);          
    $(streamView).insertAfter(
        $(".outer-stage[data-stage-id='" + stageId + "'] ul li").last()
    );            
    lines.autoJoinDelay(pipeline, 0); // redraw immediately ... no delay
  }
}



/** We will want to redraw the joins in some cases */
function addAutoJoinHooks(pipeline) {
  $("#pipeline-visual-editor").on('click', ".autojoin", function() {
    lines.autoJoinDelay(pipeline);
  });
}

/** clicking on a step will open the editor */
function addOpenStepListener(pipeline, formFields) {
  $("#pipeline-visual-editor").on('click', ".open-editor", function(){
    openEditor(pipeline, $( this ).attr('data-action-id'), formFields);
  });
}

/** clicking on add a step should open a popover with a selection of available steps */
function addNewStepListener(pipeline, formFields) { // jshint ignore:line
  $("#pipeline-visual-editor").on('click', ".open-add-step", function(){
    var stageId = $( this ).attr('data-stage-id');
    var newStepP = $('#add-step-popover-' + stageId);
    newStepP.popover({'content' : newStepBlock(stageId, steps), 'html' : true});
    newStepP.popover('show');      
    $("#addStepBtn-" + stageId).off('click').click(function() {        
       handleAddNewStep(newStepP, pipeline, formFields, stageId);
    });
    $("#newStepName-" + stageId).off('keydown').keydown(function(e) {
      if (e.which === 13) {
        handleAddNewStep(newStepP, pipeline, formFields, stageId);
      }
    });
  });
}

/** Add the new step and redraw just the current stage listing of steps */
function handleAddNewStep(newStepP, pipeline, formFields, stageId) {
  var selected = document.querySelector('input[name="newStepType-' + stageId + '"]:checked');
  var name = $('#newStepName-' + stageId).val();
  newStepP.popover('toggle');
  if (selected) {
      if (!name) {
        name = "New Step";
      }
      var newStep = {"type": selected.value, "name": name};
      var insertResult = wf.insertStep(pipeline, stageId, newStep);
      writeOutChanges(pipeline, formFields);
      refreshStepListing(stageId, insertResult.stepContainer.steps);
      lines.autoJoinDelay(pipeline, 0); // redraw immediately ... no delay
      openEditor(pipeline, insertResult.actionId, formFields);            
  }
}

/** the popover for a new step */
function newStepBlock(stageId, pipelineEditors) {  
  return require('./templates/step-block.hbs')({
      stageId: stageId,
      steps: pipelineEditors
  });  
}

/** clicking on add a stage will at least ask a user for a name */
function addNewStageListener(pipeline, formFields) { // jshint ignore:line
  $("#pipeline-visual-editor").on('click', ".open-add-stage", function() {
    var newStageP = $('#add-stage-popover');
    newStageP.popover({'content': newStageBlock(), 'html': true});
    newStageP.popover('show');

    function addStage() {
      newStageP.popover('toggle');
      var newStageName = $("#newStageName").val();
      if (newStageName !== '') {
        pipeline.push({"name": newStageName, "steps": []});
        redrawPipeline(pipeline, formFields);
      }
    }

    $('#addStageBtn').off('click').click(function() {
      addStage();
    });
    $("#newStageName").off('keydown').keydown(function (e) {
      if (e.which === 13) {
        addStage();
      }
    });
    $("#newStageName").focus();
  });
}

/** the popover for a new  stage */
function newStageBlock() {
   return require('./templates/stage-block.hbs')();
}


/** apply changes to any form-control elements */
function addApplyChangesHooks(pipeline, formFields) {
   $(".currently-editing").change(function() {
     var actionId = $( this ).attr('data-action-id');     
     handleEditorSave(pipeline, actionId, formFields);
   });   
   $(".close-editor-popover").click(function() {
     var actionId = $( this ).attr('data-action-id');
     var editorP = $("#show-editor-popover-" + actionId);
     editorP.popover('destroy');     
   });
   $(".delete-current-step").click(function() {
     if (window.confirm("Are you sure you want to delete this step?")) {
        var actionId = $( this ).attr('data-action-id');
        var editorP = $("#show-editor-popover-" + actionId);
        wf.removeActionId(pipeline, actionId);
        redrawPipeline(pipeline, formFields);
        editorP.popover('destroy');         
     }  
     
   });
   
}

/**
 * For the given pipeline, put the values in the script and json form fields.
 */ 
function writeOutChanges(pipeline, formFields) {
    var generatedScript = wf.toWorkflow(pipeline, steps);
    formFields.script.val(generatedScript);
    formFields.json.val(stringify.writeJSON(pipeline));
    console.log(generatedScript);
}
exports.writeOutChanges = writeOutChanges;

/**
 * parallel stages are an item in an ordered list.
 */
function parStageBlock(stageName, subStageId, subStage, stageId) {
  return require('./templates/parallel-stage-block.hbs')({
      stageName: stageName,
      subStageId: subStageId,
      subStage: subStage,
      stageId: stageId,
      stepListing: stepListing(subStageId, subStage.steps)
  });
}
exports.parStageBlock = parStageBlock;
 
/**
 * A non parallel stage. Parallel stages are a pipeline editor construct, not an inherent workflow property.
 */
function normalStageBlock(currentId, stage) {
  return require('./templates/normal-stage-block.hbs')({
      currentId: currentId,
      stage: stage,
      stepListing: stepListing(currentId, stage.steps)
  });
}
exports.normalStageBlock = normalStageBlock;

/**
 * Take a list of steps and return a listing of step buttons
 */
function stepListing(stageId, steps)  {
    return require('./templates/steps-listing.hbs')({
        stageId: stageId,
        steps: steps
    });
}

function refreshStepListing(stageId, steps)  {
    var content = stepListing(stageId, steps);
    $('#' + stageId + ' .step-listing').replaceWith(content);
}

/**
 * Taking the actionId (co-ordinates), find the step info and load it up.
 */
function openEditor(pipeline, actionId, formFields) {  
  var editorP = $("#show-editor-popover-" + actionId);
  var coordinates = wf.actionIdToStep(actionId);
  var stepInfo = wf.fetchStep(coordinates, pipeline);
  var editorModule = steps[stepInfo.type];
  var editorHtml = editorModule.renderEditor(stepInfo, actionId); 
  var content = require('./templates/editor-popover.hbs')({
      actionId : actionId, 
      editorHtml: editorHtml      
  });

  editorP.popover({'content' : content, 'html' : true});
  editorP.popover('show');

  addApplyChangesHooks(pipeline, formFields);
    
  $(".open-editor").removeClass('selected');
  $(".open-editor[data-action-id='" + actionId + "']").addClass('selected');
  $('.form-group').first().focus();
  
}

/**
 * When a change is made to a step config, this will be called to apply the changes.
 */
function handleEditorSave(pipeline, actionId, formFields) {
  var currentStep = wf.fetchStep(wf.actionIdToStep(actionId), pipeline);
  var edModule = steps[currentStep.type];
  if (edModule.readChanges(actionId, currentStep)) {
      console.log("applied changes for " + actionId);
      writeOutChanges(pipeline, formFields);
  }
}

},{"./model/stringify":16,"./model/workflow":17,"./steps":22,"./svg/lines":31,"./templates/editor-popover.hbs":33,"./templates/normal-stage-block.hbs":34,"./templates/parallel-stack.hbs":35,"./templates/parallel-stage-block.hbs":36,"./templates/stage-block.hbs":37,"./templates/stage-button.hbs":38,"./templates/stage-config-block.hbs":39,"./templates/step-block.hbs":40,"./templates/steps-listing.hbs":41,"./templates/stream-block.hbs":42,"./templates/stream-button.hbs":43,"./templates/stream-config-block.hbs":44,"jenkins-js-modules":10}],15:[function(require,module,exports){
/**
 * The json model of the data: 
 * pipeline is a [list of stages]
 * each stage is an object that is either an ordinary stage, or a parallel stage.
 * (this is not a workflow script concept, just a model abstraction here).
 * 
 * An ordinary stage: { "name" : for display purposes and logging, "steps" : [list of steps]}
 * a step: { "name" : for display purposes only, "type" : determines what editor is loaded. }
 * 
 * A parallel stage: { "name": ..., "streams" : [list streams] }
 *  A "stream" is sometimes called a "branch" in workflow examples, but this is confusing with SCM branches, 
 *  so I have called it a stream. 
 *  A stream is similar to a stage, { "name" : ... , "steps" : [list of steps]} containing steps.
 *  The name of the stream is used in logs, and for display, however it is all under the one 
 *  workflow "stage". 
 * 
 * See the samples below to make this more concrete.
 */

/**
 * Load the json from the json field, if its a new job lets apply a default.
 */
exports.loadModelOrUseDefault = function(jsonText) {  
  if (exports.existingPipeline(jsonText)) {
    var pipelineParsed = JSON.parse(jsonText);
    return pipelineParsed;
  } else {
    console.log("No pipeline has been saved, applying a sample template");
    return simpleSample;
  }    
};

/** if not valid json then we need to resort to a sample */
exports.existingPipeline = function(jsonText) {
  return jsonText !== null && jsonText !== "";
};

/* some sample json starting points to default to */

var simpleSample = [
  {
    "name" : "Checkout and Build",
    "steps" : [
      {"type": "git", "name" : "Clone webapp", "url" : "https://github.com/michaelneale/sample-pipeline-project.git"},
      {"type": "sh", "name" : "Build", "command" : "echo 'hello world'"}
    ]    
  },
  
  {
    "name" : "Test",
    "streams" : [
      {"name" : "Unit", "steps" : [
        {"type": "sh", "name" : "Run unit test suite", "command" : "./bin/ci/test"}
      ]},
      {"name" : "Integration","steps" : [
        {"type": "sh", "name" : "Run slower tests", "command" : "./bin/ci/integration-tests"}        
      ]}
    ]    
  },
  
  {
    "name" : "Deploy",
    "steps" : [
      {"type": "sh", "name" : "Deploy to staging", "command" : "./bin/ci/deploy"},
    ]    
  }
  
  
];
exports.simpleSample = simpleSample;


exports.complexSample = 
[
  {
    "name" : "Checkout",
    "steps" : [
      {"type": "git", "name" : "Clone webapp", "url" : "git@github.com/thing/awesome.git"},
    ]    
  },
  
  
  {
    "name" : "Prepare Test Database",
    "steps" : [
      {"type": "sh", "name" : "Install Postgress", "command" : "install_postgres"},
      {"type": "sh", "name" : "Initialise DB", "command" : "pgsql data/init.sql"},
    ]    
  },
  
  
 
  {
    "name" : "Prepare",
    "streams" : [
      {"name" : "Ruby", "steps" : [
        {"type": "sh", "name" : "Install Ruby", "command" : "/bin/ci/install_ruby version=2.0.1"},
        {"type": "stash", "name" : "Stash compiled app", "includes": "/app", "excludes" : ""} 
      ]},
      {"name" : "Python","steps" : [
        {"type": "sh", "name" : "Yeah", "command" : "exit()"}
        
      ]}
    ]    
  },
  
  {
    "name" : "Stage and Test",
    "steps" : []    
  },
  
  {
    "name" : "Approve",
    "steps" : [],
    "type" : "input"    
  },
  
  {
    "name" : "Deploy",
    "steps" : [],
    "node" : "devops-production"    
  },
  
  {
    "name" : "Party",
    "steps" : [{"type": "rick", "name" : "Awesome" } ]    
  }

  
];

},{}],16:[function(require,module,exports){
/**
 * Awful hack to get around JSONifying things with Prototype taking over wrong. ugh. Prototype is the worst.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad.
 * Prototype is bad and you should feel bad. 
 */
exports.writeJSON = function(o) {
	if(Array.prototype.toJSON) { // Prototype f's this up something bad
		var protoJSON = {
			a: Array.prototype.toJSON,
			o: Object.prototype.toJSON,
			h: Hash.prototype.toJSON,
			s: String.prototype.toJSON
		};
	    try {
	        delete Array.prototype.toJSON;
  	    	delete Object.prototype.toJSON;
	        delete Hash.prototype.toJSON;
	        delete String.prototype.toJSON;
	        
	    	return JSON.stringify(o);
	    }
	    finally {
	    	if(protoJSON.a) {
	    		Array.prototype.toJSON = protoJSON.a;
	    	}
	    	if(protoJSON.o) {
	    		Object.prototype.toJSON = protoJSON.o;
	    	}
	    	if(protoJSON.h) {
	    		Hash.prototype.toJSON = protoJSON.h;
	    	}
	    	if(protoJSON.s) {
	    		String.prototype.toJSON = protoJSON.s;
	    	}
	    }
	}
	else {
		return JSON.stringify(o);
	}
};

},{}],17:[function(require,module,exports){
/**
 * Contains magic for rendering out to workflow script from the json model.
 * 
 * In some places we use the convention "stageId" style string to point to what stage we are talking about. This stage id is of the form: 
 *     stage-X for a "normal" stage. and stage-X-Y to specity the stream in a parallel stage.
 * In some places we use actionId. This is the coordinates to a step. 
 *     stage-0-0 wll indicate it is the first step of the first stage. 
 *     stage-0-0-0 will indicate it is the first step of the first stream of the first stage. 
*       ie stage-<stage>-<step> if normal. stage-<stage>-<stream>-<step> if it has parallel.
 */

exports.isParallelStage = isParallelStage;
exports.toWorkflow = toWorkflow;
exports.insertStep = insertStep;
exports.stageIdToCoordinates = stageIdToCoordinates;
exports.actionIdToStep = actionIdToStep;
exports.fetchStep = fetchStep;
exports.parallelToNormal = parallelToNormal;
exports.makeParallel = makeParallel;
exports.toggleParallel = toggleParallel;
exports.removeActionId = removeActionId;
exports.removeStage = removeStage;

/**
 * a parallel stage has to have streams
 */
function isParallelStage(stage) {
  if (stage.streams && stage.streams.length > 0) {
    return true;
  } else {
    return false;
  }
}

/**
 * take the pipeLineData model and insert the newStep at the end of the stage.
 * A stage may be stage-0 or stage-1-1, for example (latter if it is a multi stream stage)
 */
function insertStep(pipelineData, stageId, newStep) {
  var coords = stageIdToCoordinates(stageId);
  var stepContainer;
  if (coords.length === 1) {
    stepContainer = pipelineData[coords[0]];
  } else {
    stepContainer = pipelineData[coords[0]].streams[coords[1]];
  }
  stepContainer.steps.push(newStep);
  return {
    actionId: stageId + "-" + (stepContainer.steps.length - 1),
    stepContainer: stepContainer
  };
}


/** 
 * get the array coordinates of a stage
 * ["stage-0"] -> [0]
 * ["stage-1-1"] -> [1,1]
 */
function stageIdToCoordinates(stageId) {
  var elements = stageId.split('-');
  switch (elements.length) {
    case 2:
      return [parseInt(elements[1])];
    case 3:
      return [parseInt(elements[1]), parseInt(elements[2])];
    default: 
      console.log("ERROR: not a valid stageId");
  }    
}

/** Toggle the parallel-ness of a stage */
function toggleParallel(pipeline, stageId) {
  var coords = stageIdToCoordinates(stageId);
  if (isParallelStage(pipeline[coords[0]])) {
    parallelToNormal(pipeline, stageId);
  } else {
    makeParallel(pipeline, stageId);
  }
}

/**
 * Convert a stage that is already parallel, to one that is normal, but combining the streams. 
 */
function parallelToNormal(pipeline, stageId) {
    var coords = stageIdToCoordinates(stageId);
    var stage = pipeline[coords[0]];    
    var streams = stage.streams;    
    var newSteps = streams.reduce(function(acc, val){
      return acc.concat(val.steps);
    }, []);    
    delete stage.streams;
    stage.steps = newSteps;
}

/**
 * Take a normal stage which is a list of steps, and split it evenly to parallel streams. 
 * Use the name of the first steps as the stream name. 
 */
function makeParallel(pipeline, stageId) {
   var coords = stageIdToCoordinates(stageId);
   var stage = pipeline[coords[0]];    
   var steps = stage.steps;
   
   var splitAt = Math.floor(steps.length/2);
   var leftSteps = [];
   var rightSteps = [];
   for (var i=0; i < steps.length; ++i) {
     if (i < splitAt) {
       leftSteps.push(steps[i]);
     } else {
       rightSteps.push(steps[i]);
     }
   }
   var leftName = '';
   var rightName = '';   
   if (leftSteps[0]) {
     leftName = leftSteps[0].name;
   }
   if (rightSteps[0]) {
     rightName = rightSteps[0].name;
   }
   
   delete stage.steps;
   stage.streams = [
     {"name" : leftName, "steps" : leftSteps},
     {"name" : rightName, "steps" : rightSteps}
   ];
   
}

/** 
 * given an action id like stage-1-2 - remove it from the pipeline
 */
function removeActionId(pipeline, actionId) {
   var coords = actionIdToStep(actionId);
   if (coords.length === 2) {
     pipeline[coords[0]].steps.splice(coords[1], 1);
   } else {
     pipeline[coords[0]].streams[coords[1]].steps.splice(coords[2], 1);
   }
}

/** Remove a whole stage, which may actually be a streamId or a stageId
 * stage-0 or stage-0-1 for example.
 */
function removeStage(pipeline, stageId) {
    var coords = stageIdToCoordinates(stageId);
    if (coords.length === 1) {
      pipeline.splice(coords[0], 1);
    } else {
      pipeline[coords[0]].streams.splice(coords[1], 1);
    }
}

/**
 * an actionId is something like stage-1-2 or stage-1-2-3
 * This will return an array of the step co-ordinates.
 * So stage-1-2 = [1,2]
 *    stage-1-2-3 = [1,2,3]
 * the first number is the stage index, second is the step or stream index. 
 * the third number is if it is a parallel stage (so it is [stage, stream, step]) 
 */
function actionIdToStep(actionId) {
    var elements = actionId.split('-');
    switch (elements.length) {
      case 3:
        return [parseInt(elements[1]), parseInt(elements[2])];
      case 4:
        return [parseInt(elements[1]), parseInt(elements[2]), parseInt(elements[3])];  
      default: 
        console.log("ERROR: not a valid actionId");
    }
}


/**
 * Take 2 or 3 indexes and find the step out of the pipelineData.
 */
function fetchStep(coordinates, pipelineData) {
   if (coordinates.length === 2) {
     return pipelineData[coordinates[0]].steps[coordinates[1]];
   } else {
     return pipelineData[coordinates[0]].streams[coordinates[1]].steps[coordinates[2]];
   }
}




/**
 * Print out the workflow script using the given modules to render the steps. 
 */ 
function toWorkflow(pipelineData, modules) {
  function toStreams(streamData, modules) {
    var par = "\n    parallel (";  
    for (var i = 0; i < streamData.length; i++) {
        var stream = streamData[i];
        par += '\n     "' + stream.name + '" : {';
        par += toSteps(stream.steps, modules);      
        if (i === (streamData.length - 1)) {
            par += "\n     }";
        } else {
            par += "\n     },";
        }
    }
    return par + "\n    )"; 
  }

  function toSteps(stepData, modules) {
    var steps = "";
    for (var i = 0; i < stepData.length; i++) {
      var stepInfo = stepData[i];  
      var mod  = modules[stepInfo.type];
      steps += "\n        " + mod.generateScript(stepInfo);
    }
    return steps;
  }

  var inner = "";
  for (var i = 0; i < pipelineData.length; i++) {
    var stage = pipelineData[i];
    inner += '\n    stage name: "' + stage.name + '"';
    if (stage.streams) {      
      inner += toStreams(stage.streams, modules);
    } else {
      inner += toSteps(stage.steps, modules);
    }
  }  
  return "node {" + inner + "\n}";  
}

},{}],18:[function(require,module,exports){
require('jenkins-js-modules').whoami('undefined:pipelineeditor');

require('jenkins-js-modules')
    .import('bootstrap:bootstrap3', 'handlebars:handlebars3')
    .onFulfilled(function() {

/**
 * Jenkins pipeline editor adjunct and entry point.
 */
 
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();
var h = require('./editor');
var Belay = require('./svg/svg'); 
var lines = require('./svg/lines'); 
var storage = require("./model/json");
var editors = require('./steps');
var win = require('window-handle').getWindow();

win.mic = $; //For debugging! - you can use `mic` as jquery.
win.Belay = Belay;
/* print out what editors are registered for use */
console.log(editors);

/** 
 * Hook in to the edit button on the regular jenkins job config screen 
 * There may need to be changes here to do the equivalent of Behaviour js-Prototype code.
 * (scroll down the bottom to see the original code concept).
 *
 * Get both the script and the json text that is stored in config.xml
 */
$(document).ready(function () {    
  var script = $("input[name='_.script']");
  var json = $("input[name='_.json']");
  var confEditor = $('#page-body > div');
  var pageBody = $('#page-body');
  if ("#pipeline-editor" === win.location.hash) {
    showEditor($, confEditor, pageBody, script, json);
  }
  $('#edit-pipeline').click(function() {
    showEditor($, confEditor, pageBody, script, json);
  });
});

/**
 * Clear the regular jenkins conf editor, show the pipeline editor
 */ 
function showEditor($, confEditor, pageBody, script, json) {
  confEditor.hide();    
  win.location.hash = "#pipeline-editor";
  pageBody.append("<div id='pipeline-visual-editor'>" +
                  "<div class='bootstrap-3'><p>" +
                  fixFlowCSS() +
                  pipelineEditorArea() +
                  detailContainer() +
                  "<div class='container'><input id='back-to-config' type=button class='btn btn-primary' value='Save'></input></div>"+
                  "</div></div>");
                  
  $('#back-to-config').click(function() {          
    $("#pipeline-visual-editor").remove();     
    win.location.hash = "";
    Belay.off();
    confEditor.show();       
    $('#main-panel > form').submit();
    
    //remove the absolute position from the bottom sticker on return
    //otherwise the buttons may not appear until a resize. LOL (probably a better solution)
    //TODO: must be a better way.
    $('#bottom-sticker').attr('style', function(i, style) {
          return style.replace(/position[^;]+;?/g, '');
    });    
  });
  
  
  var pipeline = storage.loadModelOrUseDefault(json.val());

  lines.initSVG();
  
  if (!storage.existingPipeline(json.val())) {
    console.log("Brand new pipeline so saving the changes the first time");
    h.writeOutChanges(pipeline, {"script" : script, "json" : json });
  } 
  
  h.drawPipeline(pipeline, {"script" : script, "json" : json });
  reJoinOnResize(pipeline);
  
  window.onpopstate = function() {
      window.location = window.location.pathname;
  };

   
}



/** The bit that holds the pipeline visualisation */
function pipelineEditorArea() {
  return '<div class="container stage-listing">' +
    '<div id="pipeline-row" class="row"></div>' +
   '</div>';
}


/** container for holding the specific editors depending on what is clicked */
function detailContainer() {
  return '<div class="container stage-detail">' +
    '<div class="row">' +
      '<h3 class="col-md-12" id="editor-heading"></h3>' +
      '<div class="row">' +
        '<div class="col-md-12">' +
          '<div class="panel panel-default">' +
                '<div id="editor-panel" class="panel-body editor-detail">' +
                    'Click on a Step to view the details. ' +
                '</div>' +
          '</div>' +
        '</div>' +
      '</div>' +
    '</div>' +
  '</div>';
}

/** 
 * This will fix a problem with wrapping elements in bootstrap 
 * this is documented here: http://stackoverflow.com/questions/25598728/irregular-bootstrap-column-wrapping 
 * Without this, things won't wrap clearly left to right. Read it. 
 */
function fixFlowCSS() {
  return '<style>.stage-listing > .row > .col-md-3:nth-child(4n+1) {' +
    'clear: both;' +
  '}</style>';
}

/**
 * As svg lines are overlayed based on positions of divs, when the divs move around
 * the lines need to be redrawn.
 */
function reJoinOnResize(pipeline) {
  $(window).resize(function(){            
    lines.autoJoin(pipeline);
  });
}




/**
 * Originally we used this prototype snipped to create the edit button and clear
 * doens't play nice with the new stuff, but kept here for reference as 
 * some of the behaviour stuff may need to be retrofitted to the jquery based code.
 * Behaviour.specify("INPUT.pipeline-editor", 'pipeline-editor-button', 0, function(e) {
         var script = e.next("input");
         var json = script.next("input");

         makeButton(e,function(_) {
             var pageBody = $('page-body');
             var row = pageBody.down(".row");

             row.style.display = "none";

             pageBody.insert({bottom:"<div class=pipeline-editor style='padding:3em'><b>pipeline-editor</b><input type=button name=accept value=Accept></div>"});

             var canvas = pageBody.down("> .pipeline-editor");
             var accept = canvas.down("> INPUT");

             makeButton(accept,function(_){
                 // update fhe form values
                 script.value = "...";
                 json.value = "...";

                 // kill the dialog
                 canvas.remove();
                 row.style.display = "block";
             });
         });
 });
 */

		require('jenkins-js-modules').export(undefined, 'pipelineeditor', {});
    });

require('jenkins-js-modules').addModuleCSSToPage('bootstrap', 'bootstrap3');

},{"./editor":14,"./model/json":15,"./steps":22,"./svg/lines":31,"./svg/svg":32,"jenkins-js-modules":10,"window-handle":13}],19:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();


module.exports = {
    description: "Archive an artifact permanently",        
    renderEditor : function(stepInfo, actionId) {      
      // provide a form to edit
      var template = '<div class="form-group">' +
                        '<p class="help-block">Store an artifact permanently as part of a build record.</p>' +
                        '<label for="{{actionId}}_includes">Includes</label>' +
                        '<input id="{{actionId}}_includes" type="text" class="form-control" placeholder="./results" value="{{includes}}">' +
                        '<label for="{{actionId}}_excludes">Excludes</label>' +
                        '<input id="{{actionId}}_excludes" type="text" class="form-control" placeholder="./work" value="{{excludes}}">' +                        
                        '<div class="form-group">' +
                          '<label for="{{actionId}}_stepName">Step name</label>' +
                          '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Run a shell command" value="{{name}}">' +
                        '</div>' +                        
                      '</div>';
      var info = $.extend({"includes" : ""}, stepInfo);                      
      info = $.extend({"excludes" : ""}, info);                      
      return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.includes = $('#' + actionId + "_includes").val();
      currentStep.excludes = $('#' + actionId + "_excludes").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.excludes === "") {
        return 'archive "' + stepInfo.includes + '"';
      }
      return 'archive excludes: "' + stepInfo.excludes + '", includes: "' + stepInfo.includes + '"';
    },
};

},{"./template":28,"jenkins-js-modules":10}],20:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

module.exports = {
    description: "Set an environment variable",        
    
    renderEditor : function(stepInfo, actionId) {          
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_envName">Variable Name</label>' +
                      '<input type="text" id="{{actionId}}_envName" class="form-control" style="font-family:monospace;" value="{{envName}}">' +
                      '<label for="{{actionId}}_envValue">Variable Value</label>' +
                      '<input type="text" id="{{actionId}}_envValue" class="form-control" style="font-family:monospace;" value="{{envValue}}">' +
                      '<p class="help-block">Environment variable will be available for subsequent steps.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Set an env variable" value="{{name}}">' +
                      '</div>' +
                    '</div>';      
        
        var info = $.extend({"envValue" : ""}, stepInfo);
        info = $.extend({"envName" : ""}, info);
        return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.envValue = $('#' + actionId + "_envValue").val();
      currentStep.envName = $('#' + actionId + "_envName").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.envValue && stepInfo.envName && stepInfo.envName !== '') {
          return "env." + stepInfo.envName + " = '" + stepInfo.envValue + "'";
      } else {
          return "// no environment name or variable set for step " + stepInfo.name;
      }
      
    },
};

},{"./template":28,"jenkins-js-modules":10}],21:[function(require,module,exports){
/**
 * Basic git step.
 */

var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();


module.exports = {
    description: "Clone a git repository",        
    renderEditor : function(stepInfo, actionId) {      
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_url">Git repository to clone</label>' +
                      '<input id="{{actionId}}_url" type="text" class="form-control" placeholder="git@github.com:cloudbees/sample.git" value="{{url}}">' +                      
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Git clone" value="{{name}}">' +
                      '</div>' +
                    '</div>';        
      
      return renderTemplate(template, stepInfo, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.url = $('#' + actionId + "_url").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      return 'git \'' + stepInfo.url + '\'';
    },
};

},{"./template":28,"jenkins-js-modules":10}],22:[function(require,module,exports){
/**
 * Editor modules for the built in steps.
 * This just wraps up the editor modules in this directory
 *
 * The installEditors function is called by the main adjunct, but it doesn't really matter
 * where it is called from, as long as they are installed before they are needed.
 */

var editorModules = {
  "sh" : require('./shell'),
  "git" : require('./git'),
  "sleep" : require("./sleep"),
  "input" : require("./input"),
  "env" : require("./env"),
  "archive" : require("./archive"),
  "stash" : require('./stash'),  
  "unstash" : require('./unstash'),  
  "rick" : require('./rick'),
  "workflow" : require('./workflowScript') 
};

module.exports = editorModules;

// TODO: Get this info from Jenkins. See CJP-3974

},{"./archive":19,"./env":20,"./git":21,"./input":23,"./rick":24,"./shell":25,"./sleep":26,"./stash":27,"./unstash":29,"./workflowScript":30}],23:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

module.exports = {
    description: "Wait for user approval",        
    
    renderEditor : function(stepInfo, actionId) {          
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_question">Prompt to user</label>' +
                      '<input type="text" id="{{actionId}}_question" class="form-control" value="{{question}}">' +
                      '<p class="help-block">A short question to ask the user to let them to decide if to proceed or not.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Run a shell command" value="{{name}}">' +
                      '</div>' +
                    '</div>';      
        
        var info = $.extend({"question" : ""}, stepInfo);                                  
        return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    /** return true if this should happen outside of a node block in the generated script */
    isTopLevel : function(/* stepInfo */) {
      return true;
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.question = $('#' + actionId + "_question").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.question) {
          return "input '" + stepInfo.question + "'";
      } else {
         return '// ' + stepInfo.name;
      }
      
    },
};

},{"./template":28,"jenkins-js-modules":10}],24:[function(require,module,exports){
/**
 * A rick rolling module.
 */

var renderTemplate = require('./template').renderTemplate;

module.exports = {
    description: "Never going to give you up",        
    renderEditor : function(stepInfo, actionId) {      
      // provide a form to edit
      var template = '<div class="embed-responsive embed-responsive-4by3">' +
                        '<iframe class="embed-responsive-item" src="https://www.youtube.com/embed/dQw4w9WgXcQ">' +
                        '</iframe>' +
                     '</div>';              
      return renderTemplate(template, stepInfo, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      console.log("current step for rick is" + currentStep + actionId);
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      console.log(stepInfo);
      return '/* you have been rick rolled */';
    },
};

},{"./template":28}],25:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

module.exports = {
    description: "Run a shell script",        
    
    renderEditor : function(stepInfo, actionId) {          
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_command">Command</label>' +
                      '<textarea id="{{actionId}}_command" class="form-control" rows=5 style="font-family:monospace;">{{command}}</textarea>' +
                      '<p class="help-block">Run a command in the currently allocated build server. All standard shell scripting commands apply.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Run a shell command" value="{{name}}">' +
                      '</div>' +
                    '</div>';      
        
        var info = $.extend({"command" : ""}, stepInfo);
        return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.command = $('#' + actionId + "_command").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.command) {
          return "sh '''" + stepInfo.command.replace(/'/g, "\\'") + "'''";
      } else {
         return '// no command set for step';
      }
      
    },
};

},{"./template":28,"jenkins-js-modules":10}],26:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

module.exports = {
    description: "Wait for a specified time",        
    
    renderEditor : function(stepInfo, actionId) {          
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_seconds">How many seconds to sleep</label>' +
                      '<input type="number" id="{{actionId}}_seconds" class="form-control" value="{{sleepSeconds}}">' +
                      '<p class="help-block">Wait for the specified number of seconds.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Run a shell command" value="{{name}}">' +
                      '</div>' +
                    '</div>';      
        
        var info = $.extend({"sleepSeconds" : ""}, stepInfo);                                  
        return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.sleepSeconds = $('#' + actionId + "_seconds").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.sleepSeconds) {
          return 'sleep ' + stepInfo.sleepSeconds;
      } else {
         return '// ' + stepInfo.name;
      }
      
    },
};

},{"./template":28,"jenkins-js-modules":10}],27:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();


module.exports = {
    description: "Stash artifacts temporarily",        
    renderEditor : function(stepInfo, actionId) {      
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_name">Name of stash</label>' +
                      '<input id="{{actionId}}_name" type="text" class="form-control" placeholder="Build Results" value="{{name}}">' +                      
                      '<p class="help-block">This name is used when you need to unstash onto a new node.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_includes">Include these files</label>' +
                        '<input id="{{actionId}}_includes" type="text" class="form-control" placeholder="./target" value="{{includes}}">' +
                        '<label for="{{actionId}}_excludes">Exclude these files</label>' +
                        '<input id="{{actionId}}_excludes" type="text" class="form-control" placeholder="" value="{{excludes}}">' +                        
                      '</div>' +
                    '</div>';        
      
      return renderTemplate(template, stepInfo, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_name").val();
      currentStep.includes = $('#' + actionId + "_includes").val();
      currentStep.excludes = $('#' + actionId + "_excludes").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      return 'stash name: "' + stepInfo.name + '", includes: "' + stepInfo.includes + '", excludes: "' + stepInfo.excludes + '"';
    },
};

},{"./template":28,"jenkins-js-modules":10}],28:[function(require,module,exports){
/**
  * Templating in a few bytes eh.
  */
exports.renderTemplate = function(template, values, moreValues) {
  var result = template;
  var key;
  for (key in values) {    
    result = result.split("{{" + key + "}}").join(values[key]);    
  }
  if (moreValues) {
    for (key in moreValues) {
      result = result.split("{{" + key + "}}").join(moreValues[key]);    
    }
  }
  return result;
};

},{}],29:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();


module.exports = {
    description: "Unstash temporary artifacts",        
    renderEditor : function(stepInfo, actionId) {      
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_name">Name of stash</label>' +
                      '<input id="{{actionId}}_name" type="text" class="form-control" placeholder="Build Results" value="{{name}}">' +                      
                      '<p class="help-block">This is the name that was used to temporarily stash artifacts.</p>' +
                      '</div>' +
                    '</div>';        
      
      return renderTemplate(template, stepInfo, { "actionId" : actionId });      
    },
    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_name").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      return 'unstash "' + stepInfo.name + '"';
    },
};

},{"./template":28,"jenkins-js-modules":10}],30:[function(require,module,exports){
var renderTemplate = require('./template').renderTemplate;
var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

module.exports = {
    description: "Jenkins Workflow script",        
    
    renderEditor : function(stepInfo, actionId) {          
      // provide a form to edit
      var template = '<div class="form-group">' +
                      '<label for="{{actionId}}_command">Workflow Script</label>' +
                      '<textarea id="{{actionId}}_command" class="form-control" rows=5 style="font-family:monospace;">{{scriptSnippet}}</textarea>' +
                      '<p class="help-block">Run any Jenkins Workflow script. See <a href="https://github.com/jenkinsci/workflow-examples" target="_blank">some examples</a>.</p>' +
                      '</div>' +
                      '<div class="form-group">' +
                        '<label for="{{actionId}}_stepName">Step name</label>' +
                        '<input id="{{actionId}}_stepName" type="text" class="form-control" placeholder="Run a Jenkins Workflow script snippet" value="{{name}}">' +
                      '</div>' +
                    '</div>';      
        
        var info = $.extend({"scriptSnippet" : ""}, stepInfo);
        return renderTemplate(template, info, { "actionId" : actionId });      
    },
    
    /** return true if this should happen outside of a node block in the generated script */
    isTopLevel : function(/* stepInfo */) {
      return true;
    },

    
    readChanges : function(actionId, currentStep) {
      // read the changes from the form and apply them. 
      // if it all checks out, return true, otherwise don't apply them, and return false. 
      currentStep.name = $('#' + actionId + "_stepName").val();
      currentStep.scriptSnippet = $('#' + actionId + "_command").val();
      return true; //this will cause pipeline view to be re-rendered.
    },
    
    generateScript : function(stepInfo){
      if (stepInfo.scriptSnippet) {
          return stepInfo.scriptSnippet;
      } else {
         return '// no workflow script set for step';
      }
      
    },
};

},{"./template":28,"jenkins-js-modules":10}],31:[function(require,module,exports){
var Belay = require('./svg');
var wf = require('../model/workflow');

/**
  * Join up the pipeline elements visually allowing for parallelism.
  * 
  * from a pipeline that looks logically like: 
  * ["stage-0", ["stage-1-0", "stage-1-1"], "stage-2"]
  * 
  * Becomes: 
  * 
  *      /[]\
  * [] --    --[]
  *      \[]/
  *  
  */
function autoJoin(pipeline) {  
    Belay.off();
    var previousPils = [];    
    for (var i=0; i < pipeline.length; i++) {
      var stage = pipeline[i];
      var currentId = "stage-" + i;      
      if (!wf.isParallelStage(stage)) {      
        joinWith(previousPils, currentId);      
        previousPils = [currentId];      
      } else {      
        var currentPils = [];
        for (j = 0; j < stage.streams.length; j++) {
          currentPils[j] = currentId + "-" + j;                
        }
        for (var j=0; j < stage.streams.length; ++j) {
          if (previousPils.length === 1) {
            joinWith(previousPils, currentPils[j]);
          }
        }
        previousPils = currentPils;              
      }
    }    
}

exports.autoJoin = autoJoin;


/**
 * Draw the connecting lines using SVG and the div ids. 
 */
function joinWith(pilList, currentId) {  
  for (var i = 0; i < pilList.length; i++) {
    Belay.on("#" + pilList[i], "#" + currentId);
  }
}


/**
 * Wait until the steps are expanded before joining them together again
 */
exports.autoJoinDelay = function(pipeline, delay) {
  if (delay === undefined) {
    delay = 500;
  }    
  if (delay > 0) {
    Belay.off();
    setTimeout(function() {
      autoJoin(pipeline);
    }, delay);
  } else {
    autoJoin(pipeline);
  }
};

/**
 * Before SVG can be used need to set it up. Only needed once per whole page refresh.
 */
exports.initSVG = function() {
  Belay.init({strokeWidth: 2});
  Belay.set('strokeColor', '#999');
};

},{"../model/workflow":17,"./svg":32}],32:[function(require,module,exports){
/**
 * Use SVG to draw lines between adjacent divs. 
 */ 

var $ = require('jenkins-js-modules').require('bootstrap:bootstrap3').getBootstrap();

var settings = {
                  strokeColor       : '#fff',
                  strokeWidth       : 10,
                  opacity           : 1,
                  fill              : 'none',
                  animate           : true,
                  animationDirection: 'right',
                  animationDuration : 0.3
               };


exports.init = function(initObj) {
    if (initObj) {
      $.each(initObj, function(index, value) {
         //TODO validation on settings
         settings[index] = value;
      });
    }
};

exports.set = function(prop, val){
  //TODO validate
  settings[prop] = val;
};

exports.on = function(el1, el2){
  var $el1 = $(el1);
  var $el2 = $(el2);
  if ($el1.length && $el2.length) {
    var svgheight,
        p,
        svgleft,
        svgtop,
        svgwidth;

    var el1pos = $(el1).offset();
    var el2pos = $(el2).offset();

    var el1H = $(el1).outerHeight();
    var el1W = $(el1).outerWidth();

    var el2H = $(el2).outerHeight();

    svgleft = Math.round(el1pos.left + el1W);
    svgwidth = Math.round(el2pos.left - svgleft);

    var cpt;

    ////Determine which is higher/lower
    if( (el2pos.top+(el2H/2)) <= ( el1pos.top+(el1H/2))){
      // console.log("low to high");        
      svgheight = Math.round((el1pos.top+el1H/2) - (el2pos.top+el2H/2));
      svgtop = Math.round(el2pos.top + el2H/2) - settings.strokeWidth;        
      cpt = Math.round(svgwidth*Math.min(svgheight/300, 1));
      p = "M0,"+ (svgheight+settings.strokeWidth) +" C"+cpt+","+(svgheight+settings.strokeWidth)+" "+(svgwidth-cpt)+"," + settings.strokeWidth + " "+svgwidth+"," + settings.strokeWidth;          
    }else{
      // console.log("high to low");
      svgheight = Math.round((el2pos.top+el2H/2) - (el1pos.top+el1H/2));
      svgtop = Math.round(el1pos.top + el1H/2) - settings.strokeWidth;  
      cpt = Math.round(svgwidth*Math.min(svgheight/300, 1));
      p = "M0," + settings.strokeWidth + " C"+ cpt +",0 "+ (svgwidth-cpt) +","+(svgheight+settings.strokeWidth)+" "+svgwidth+","+(svgheight+settings.strokeWidth);                  
    }
    
    //ugly one-liner
    var $ropebag = $('#ropebag').length ? $('#ropebag') : $('body').append($( "<div id='ropebag' />" )).find('#ropebag');

    var svgnode = document.createElementNS('http://www.w3.org/2000/svg','svg');
    var newpath = document.createElementNS('http://www.w3.org/2000/svg',"path");
    newpath.setAttributeNS(null, "d", p);
    newpath.setAttributeNS(null, "stroke", settings.strokeColor);
    newpath.setAttributeNS(null, "stroke-width", settings.strokeWidth);
    newpath.setAttributeNS(null, "opacity", settings.opacity);
    newpath.setAttributeNS(null, "fill", settings.fill);      
    svgnode.appendChild(newpath);
    //for some reason, adding a min-height to the svg div makes the lines appear more correctly.
    $(svgnode).css({left: svgleft, top: svgtop, position: 'absolute',width: svgwidth, height: svgheight + settings.strokeWidth*2, minHeight: '20px' });
    $ropebag.append(svgnode);
    if (settings.animate) {
      // THANKS to http://jakearchibald.com/2013/animated-line-drawing-svg/
      var pl = newpath.getTotalLength();
      // Set up the starting positions
      newpath.style.strokeDasharray = pl + ' ' + pl;

      if (settings.animationDirection === 'right') {
        newpath.style.strokeDashoffset = pl;
      } else {
        newpath.style.strokeDashoffset = -pl;
      }

      // Trigger a layout so styles are calculated & the browser
      // picks up the starting position before animating
      // WON'T WORK IN IE. If you want that, use requestAnimationFrame to update instead of CSS animation
      newpath.getBoundingClientRect();
      newpath.style.transition = newpath.style.WebkitTransition ='stroke-dashoffset ' + settings.animationDuration + 's ease-in-out';
      // Go!
      newpath.style.strokeDashoffset = '0';
    }
  }
};

exports.off = function(){
  $("#ropebag").empty();
};

},{"jenkins-js-modules":10}],33:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<form class='currently-editing' data-action-id='"
    + alias3(((helper = (helper = helpers.actionId || (depth0 != null ? depth0.actionId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"actionId","hash":{},"data":data}) : helper)))
    + "'>\n  "
    + ((stack1 = ((helper = (helper = helpers.editorHtml || (depth0 != null ? depth0.editorHtml : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"editorHtml","hash":{},"data":data}) : helper))) != null ? stack1 : "")
    + " \n</form> \n<button class='btn btn-primary close-editor-popover' data-action-id='"
    + alias3(((helper = (helper = helpers.actionId || (depth0 != null ? depth0.actionId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"actionId","hash":{},"data":data}) : helper)))
    + "'>OK</button>\n<button class='btn btn-default delete-current-step' data-action-id='"
    + alias3(((helper = (helper = helpers.actionId || (depth0 != null ? depth0.actionId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"actionId","hash":{},"data":data}) : helper)))
    + "'>Delete</button>\n";
},"useData":true});

},{"hbsfy/runtime":9}],34:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<div class=\"col-md-3 outer-stage\" data-stage-id=\""
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "\">  \n    <div id=\""
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "\" class=\"panel panel-default stage-block collapsed\">\n        <div class=\"panel-heading\">           \n            <a role=\"button\" class=\"autojoin\" data-toggle=\"collapse\" href=\"#"
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "_collapse\">"
    + alias3(this.lambda(((stack1 = (depth0 != null ? depth0.stage : depth0)) != null ? stack1.name : stack1), depth0))
    + "</a>\n            <div class=\"collapse\" id=\""
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "_collapse\">"
    + ((stack1 = ((helper = (helper = helpers.stepListing || (depth0 != null ? depth0.stepListing : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stepListing","hash":{},"data":data}) : helper))) != null ? stack1 : "")
    + "</div>\n                        \n            <a role=\"button\" class=\"open-stage-config\" data-stage-id=\""
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "\">\n              <span class=\"glyphicon glyphicon-option-horizontal\" aria-hidden=\"true\"></span>\n            </a>\n            <div id=\"edit-stage-popover-"
    + alias3(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "\" data-placement=\"bottom\"></div>\n            \n        </div>\n    </div>\n</div>\n";
},"useData":true});

},{"hbsfy/runtime":9}],35:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function";

  return "<div class=\"col-md-3 outer-stage\" data-stage-id=\""
    + this.escapeExpression(((helper = (helper = helpers.currentId || (depth0 != null ? depth0.currentId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"currentId","hash":{},"data":data}) : helper)))
    + "\">  \n    <ul class=\"list-unstyled\"> "
    + ((stack1 = ((helper = (helper = helpers.subStages || (depth0 != null ? depth0.subStages : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStages","hash":{},"data":data}) : helper))) != null ? stack1 : "")
    + " "
    + ((stack1 = ((helper = (helper = helpers.addStreamButton || (depth0 != null ? depth0.addStreamButton : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"addStreamButton","hash":{},"data":data}) : helper))) != null ? stack1 : "")
    + " </ul>  \n</div>\n";
},"useData":true});

},{"hbsfy/runtime":9}],36:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<li>\n    <div id=\""
    + alias3(((helper = (helper = helpers.subStageId || (depth0 != null ? depth0.subStageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStageId","hash":{},"data":data}) : helper)))
    + "\" class=\"panel panel-default stage-block collapsed\">\n        <div class=\"panel-heading\">\n            <a role=\"button\" class=\"autojoin\" data-toggle=\"collapse\" href=\"#"
    + alias3(((helper = (helper = helpers.subStageId || (depth0 != null ? depth0.subStageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStageId","hash":{},"data":data}) : helper)))
    + "_collapse\">"
    + alias3(((helper = (helper = helpers.stageName || (depth0 != null ? depth0.stageName : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageName","hash":{},"data":data}) : helper)))
    + ":"
    + alias3(this.lambda(((stack1 = (depth0 != null ? depth0.subStage : depth0)) != null ? stack1.name : stack1), depth0))
    + "</a>\n            <div class=\"collapse\" id=\""
    + alias3(((helper = (helper = helpers.subStageId || (depth0 != null ? depth0.subStageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStageId","hash":{},"data":data}) : helper)))
    + "_collapse\">"
    + ((stack1 = ((helper = (helper = helpers.stepListing || (depth0 != null ? depth0.stepListing : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stepListing","hash":{},"data":data}) : helper))) != null ? stack1 : "")
    + "</div>\n            \n            <a role=\"button\" class=\"open-stream-config\" data-stage-id=\""
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" data-stream-id=\""
    + alias3(((helper = (helper = helpers.subStageId || (depth0 != null ? depth0.subStageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStageId","hash":{},"data":data}) : helper)))
    + "\">\n              <span class=\"glyphicon glyphicon-option-horizontal\" aria-hidden=\"true\"></span>\n            </a>\n            <div id=\"edit-stage-popover-"
    + alias3(((helper = (helper = helpers.subStageId || (depth0 != null ? depth0.subStageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"subStageId","hash":{},"data":data}) : helper)))
    + "\" data-placement=\"bottom\"></div>\n            \n        </div>\n    </div>\n</li>\n";
},"useData":true});

},{"hbsfy/runtime":9}],37:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    return "<div class=\"input-group\">\n    <input id=\"newStageName\" type=\"text\" class=\"form-control\" placeholder=\"New Stage Name\">\n    <span class=\"input-group-btn\"><button id=\"addStageBtn\" class=\"btn btn-default\">OK</button></span>\n</div>";
},"useData":true});

},{"hbsfy/runtime":9}],38:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    return "<div class=\"col-md-3 edit-mode\">\n    <button class=\"btn btn-default btn-block open-add-stage\">\n        <span class=\"glyphicon glyphicon-plus\"></span> <span class=\"opaque-text\">Add stage</span>\n    </button>\n    <div id=\"add-stage-popover\" data-placement=\"bottom\"></div>\n</div>";
},"useData":true});

},{"hbsfy/runtime":9}],39:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "      <div class=\"form-group\">\n        <label for=\"stageName_"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\">Stage name</label>\n        <input id=\"stageName_"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" type=\"text\" class=\"form-control\"  value=\""
    + alias3(((helper = (helper = helpers.stageName || (depth0 != null ? depth0.stageName : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageName","hash":{},"data":data}) : helper)))
    + "\">\n      </div>\n\n      <div class=\"form-group\">\n        <button id=\"closeStageConfig-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-primary\">Close</button>\n      <div>\n        \n      <div class=\"form-group\">\n        <p class=\"help-block\">You can convert this sequential block to a set of parallel branches:</p>\n        <button id=\"toggleParallel-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-warning\">Make parallel</button>        \n        <p>\n        <p class=\"help-block\">Delete whole stage and all its steps:</p>          \n        <button id=\"deleteStage-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-default\">Delete stage</button>                  \n\n      </div>\n\n  \n \n";
},"useData":true});

},{"hbsfy/runtime":9}],40:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"1":function(depth0,helpers,partials,data,blockParams,depths) {
    var helper, alias1=this.escapeExpression, alias2=helpers.helperMissing, alias3="function";

  return "<div class=\"radio\">\n    <label>\n        <input type=\"radio\" name=\"newStepType-"
    + alias1(this.lambda((depths[1] != null ? depths[1].stageId : depths[1]), depth0))
    + "\" value=\""
    + alias1(((helper = (helper = helpers.key || (data && data.key)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(depth0,{"name":"key","hash":{},"data":data}) : helper)))
    + "\" />"
    + alias1(((helper = (helper = helpers.description || (depth0 != null ? depth0.description : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(depth0,{"name":"description","hash":{},"data":data}) : helper)))
    + "\n    </label>\n</div>\n";
},"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data,blockParams,depths) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return ((stack1 = helpers.each.call(depth0,(depth0 != null ? depth0.steps : depth0),{"name":"each","hash":{},"fn":this.program(1, data, 0, blockParams, depths),"inverse":this.noop,"data":data})) != null ? stack1 : "")
    + "<div class=\"input-group\">\n    <input id=\"newStepName-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" type=\"text\" class=\"form-control\" placeholder=\"Step Name\">\n    <span class=\"input-group-btn\"><button id=\"addStepBtn-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-default\">OK</button></span>\n</div>";
},"useData":true,"useDepths":true});

},{"hbsfy/runtime":9}],41:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"1":function(depth0,helpers,partials,data,blockParams,depths) {
    var helper, alias1=this.lambda, alias2=this.escapeExpression, alias3=helpers.helperMissing, alias4="function";

  return "        <button class=\"btn btn-default btn-block open-editor\" data-action-id=\""
    + alias2(alias1((depths[1] != null ? depths[1].stageId : depths[1]), depth0))
    + "-"
    + alias2(((helper = (helper = helpers.index || (data && data.index)) != null ? helper : alias3),(typeof helper === alias4 ? helper.call(depth0,{"name":"index","hash":{},"data":data}) : helper)))
    + "\">"
    + alias2(((helper = (helper = helpers.name || (depth0 != null ? depth0.name : depth0)) != null ? helper : alias3),(typeof helper === alias4 ? helper.call(depth0,{"name":"name","hash":{},"data":data}) : helper)))
    + "</button>\n        <div id=\"show-editor-popover-"
    + alias2(alias1((depths[1] != null ? depths[1].stageId : depths[1]), depth0))
    + "-"
    + alias2(((helper = (helper = helpers.index || (data && data.index)) != null ? helper : alias3),(typeof helper === alias4 ? helper.call(depth0,{"name":"index","hash":{},"data":data}) : helper)))
    + "\" data-placement=\"bottom\"></div>\n";
},"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data,blockParams,depths) {
    var stack1, helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<div class=\"step-listing\">\n    <div class=\"step-list\">\n"
    + ((stack1 = helpers.each.call(depth0,(depth0 != null ? depth0.steps : depth0),{"name":"each","hash":{},"fn":this.program(1, data, 0, blockParams, depths),"inverse":this.noop,"data":data})) != null ? stack1 : "")
    + "    </div>\n    <button class=\"btn btn-default btn-block open-add-step edit-mode\" data-stage-id=\""
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\">\n        <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\"></span> <span class=\"opaque-text\">Add step</span>\n    </button>\n    <div id=\"add-step-popover-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" data-placement=\"bottom\"></div>\n</div>\n";
},"useData":true,"useDepths":true});

},{"hbsfy/runtime":9}],42:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<div class=\"input-group\">\n    <input id=\"newStreamName-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" type=\"text\" class=\"form-control\" placeholder=\"New Parallel Branch Name\">\n    <span class=\"input-group-btn\"><button id=\"addStreamBtn-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-default\">OK</button></span>\n</div>";
},"useData":true});

},{"hbsfy/runtime":9}],43:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<button class=\"btn btn-default btn-block open-add-stream edit-mode\" data-stage-id=\""
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\">\n    <span class=\"glyphicon glyphicon-plus\"></span> <span class=\"opaque-text\">Add parallel branch</span>\n</button>\n\n<div id=\"add-stream-popover-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" data-placement=\"bottom\"></div>\n";
},"useData":true});

},{"hbsfy/runtime":9}],44:[function(require,module,exports){
// hbsfy compiled Handlebars template
var HandlebarsCompiler = require('hbsfy/runtime');
module.exports = HandlebarsCompiler.template({"compiler":[6,">= 2.0.0-beta.1"],"main":function(depth0,helpers,partials,data) {
    var helper, alias1=helpers.helperMissing, alias2="function", alias3=this.escapeExpression;

  return "<div class=\"form-group\">\n  <label for=\"stageName_"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\">Stage name</label>\n  <input id=\"stageName_"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" type=\"text\" class=\"form-control\"  value=\""
    + alias3(((helper = (helper = helpers.stageName || (depth0 != null ? depth0.stageName : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageName","hash":{},"data":data}) : helper)))
    + "\">\n</div>\n\n<div class=\"form-group\">\n  <label for=\"stageName_"
    + alias3(((helper = (helper = helpers.streamId || (depth0 != null ? depth0.streamId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"streamId","hash":{},"data":data}) : helper)))
    + "\">Parallel Branch name</label>\n  <input id=\"streamName_"
    + alias3(((helper = (helper = helpers.streamId || (depth0 != null ? depth0.streamId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"streamId","hash":{},"data":data}) : helper)))
    + "\" type=\"text\" class=\"form-control\"  value=\""
    + alias3(((helper = (helper = helpers.streamName || (depth0 != null ? depth0.streamName : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"streamName","hash":{},"data":data}) : helper)))
    + "\">\n</div>\n\n<div class=\"form-group\">\n  <button id=\"closeStageConfig-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-primary\">Close</button>\n<div>\n  \n<div class=\"form-group\">\n  <p class=\"help-block\">You can convert this parallel set of branches to a single stage:</p>\n  <button id=\"makeSequential-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-warning\">Convert to non parallel</button>        \n  <p>\n  <p class=\"help-block\">Delete whole stage, or just the current branch:</p>          \n  <button id=\"deleteStream-"
    + alias3(((helper = (helper = helpers.streamId || (depth0 != null ? depth0.streamId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"streamId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-default\">Delete branch</button>                  \n  <button id=\"deleteStage-"
    + alias3(((helper = (helper = helpers.stageId || (depth0 != null ? depth0.stageId : depth0)) != null ? helper : alias1),(typeof helper === alias2 ? helper.call(depth0,{"name":"stageId","hash":{},"data":data}) : helper)))
    + "\" class=\"btn btn-default\">Delete stage</button>                  \n\n</div>\n";
},"useData":true});

},{"hbsfy/runtime":9}]},{},[18]);
